AC_DEFUN([AC_WITH_VAUCANSON],
[AC_ARG_WITH(
	[vaucanson],
	[AC_HELP_STRING([--with-vaucanson=DIR],
	[Directory where Vaucanson is installed])],
# Change this to a test of Vaucanson version, like for xerces.
	[echo "$withval"
	if test -r "$withval/include/vaucanson/config/system.hh"; then
	   	if test -r "/$withval/include/vaucanson/config/system.hh"; then
		   VAUCANSON=$withval
		else
		   VAUCANSON=`pwd`/$withval
		   echo $VAUCANSON
		fi
	 else
		AC_MSG_ERROR([Bad Vaucanson directory])
	 fi],
	[VAUCANSON=$ac_default_prefix])
AC_SUBST(VAUCANSON)
])


AC_DEFUN([AC_WITH_XERCESC],
[AC_ARG_WITH(
  [xercesc],
  [AC_HELP_STRING([--with-xercesc],
  		   [specify Xerces-C++ location])],
  [XERCESC_INCLUDEDIR=$withval],
  [if test "x$prefix" = xNONE; then
     XERCESC=$ac_default_prefix
   else
     XERCESC=$prefix
   fi])
AC_CHECK_XERCESC
])


AC_DEFUN([AC_CHECK_XERCESC],
  [
    ac_compile_xerces_check_save=$ac_compile
    ac_cpp_xerces_check_save=$ac_cpp
    ac_compile="$ac_compile -I${XERCESC}/include"
    ac_cpp="$ac_cpp -I${XERCESC}/include"
    AC_CHECK_HEADER(
      [xercesc/util/XercesVersion.hpp],
      [
	AC_MSG_CHECKING([Xerces-C++ version is greater than 2.3])
	AC_COMPILE_IFELSE(
	  [
            AC_LANG_SOURCE([
@%:@include <xercesc/util/XercesVersion.hpp>
@%:@if XERCES_VERSION_MAJOR != 2
@%:@ error "Bad Xerces-C++ major version."
@%:@endif
@%:@if XERCES_VERSION_MINOR < 3
@%:@ error "Bad Xerces-C++ minor version."
@%:@endif])
	  ],
          [
	    AC_MSG_RESULT([ok])
	    LIBS_xerces_check_save=$LIBS
            AC_SUBST(XERCESC)
	  ],
          [AC_ERROR([Bad Xerces-C++ version.])])
        LIBS=$LIBS_xerces_check_save
      ],
      [
	AC_ERROR([Could not find Xerces-C++ headers.])
	ac_compile=$ac_compile_xerces_check_save
	ac_cpp=$ac_cpp_xerces_check_save
      ])
])


AC_DEFUN([AC_PROG_JAVAC],
[AC_ARG_VAR([JAVAC], [Java Compiler])
AC_PATH_PROG(
	[JAVAC],
	[javac],
	[AC_MSG_ERROR([No appropriate Java compiler found. Please install Java 1.4 or higher])],
	[$JAVA_HOME:$JAVA_HOME/bin:$PATH])
AC_SUBST(JAVAC)
])



AC_DEFUN([AC_PROG_JAVA],
[AC_ARG_VAR([JAVA], [Java Virtual machine])
AC_PATH_PROG(
	[JAVA],
	[java],
	[AC_MSG_ERROR([No appropriate Java VM found. Please install Java 1.4 or higher])],
	[$JAVA_HOME:$JAVA_HOME/bin:$PATH])
AC_SUBST(JAVA)
])



AC_DEFUN([AC_PROG_JAR],
[AC_ARG_VAR([JAR], [Java Archiver])
AC_PATH_PROG(
	[JAR],
	[jar],
	[AC_MSG_ERROR([No appropriate Java Archiver found. Please install Java 1.4 or higher])],
	[$JAVA_HOME:$JAVA_HOME/bin:$PATH])
AC_SUBST(JAR)
])
