//
// AutomatonStructureProperties.java for Vcsn in
// /home/loulou/enst/VcsnInterface
// 
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
// 
// Started on  Wed Dec 15 16:36:57 2004 Loulou Pouchet
// Last update Fri Jun 24 09:16:26 2005 Loulou Pouchet
//

import vaucanson.vgitoolkit.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;
import javax.swing.JMenuBar;
import javax.swing.KeyStroke;
import javax.swing.ImageIcon;

import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFrame;

import javax.swing.filechooser.*;
import java.io.*;
import javax.swing.*;


import java.util.Map;
import java.util.Hashtable;
// JGraph
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.CellView;
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.JGraph;


// Panel for edition of automaton structure.
// - Respect of DTD with VJToolKitConstants
// - Handle edition of XML document
public class AutomatonStructureProperties
    extends PropertiesTemplate
    implements ActionListener, ItemListener 
{
    public AutomatonStructureProperties(Storage storage)
    {
	super(storage);
	frame_.setTitle("Automaton structure");
	storage_.automaton_structure_properties_set(this);
 	create_frame_elements();
    }

    
    protected void		create_frame_elements()
    {
	JPanel normal_panel = new JPanel(new BorderLayout());
	panel_alpha_in_ = create_alphabet_in_panel(); 
	panel_alpha_out_ = create_alphabet_out_panel(); 
	
	JPanel start = new JPanel(new GridLayout(2, 1));
	start.add(create_name_panel());
	start.add(create_automaton_type_panel());

	normal_panel.add(start, BorderLayout.NORTH);
	JPanel alphabets = new JPanel(new GridLayout(2, 1));
	alphabets.add(panel_alpha_in_);
	alphabets.add(panel_alpha_out_);
	normal_panel.add(alphabets, BorderLayout.SOUTH);
	normal_panel.add(create_weight_type_panel(), BorderLayout.CENTER);

// 	JPanel advanced_panel = new JPanel(new GridLayout(1, 1));
// 	advanced_panel.add(create_advanced_panel());
//  	frame_panels_set(normal_panel, advanced_panel);

 	frame_panel_set(normal_panel);
    }


    // Button for direct text edition.
    /// FIXME: Do this.
    protected JPanel		create_textedit_panel()
    {
	JButton b = new JButton("Edit XML file");
	JPanel p = new JPanel(new FlowLayout());
	p.add(b);
	return p;
    }

    
    protected JPanel		create_advanced_panel()
    {
	return new JPanel();
    }


    protected JPanel		create_name_panel()
    {
	JLabel label1 = new JLabel("Automaton name");
	name_ = new JTextField();
	
	JPanel p = new JPanel(new GridLayout(2, 1));
	p.add(label1);
	p.add(name_);

	return p;
    }


    protected JPanel		create_automaton_type_panel()
    {
	JLabel label1 = new JLabel("Automaton type");
	String[] types = { "Automaton", "FMP transducer", 
			   "Realtime transducer"};

	types_ = new JComboBox(types);
	types_.addActionListener(this);

	JPanel pc = new JPanel(new GridLayout(1, 1));
	pc.add(types_);

	JPanel p = new JPanel(new BorderLayout());
	p.add(label1, BorderLayout.NORTH);
	p.add(pc, BorderLayout.CENTER);
	
	return p;
    }

    protected JPanel		create_alphabet_in_panel()
    {
	JLabel label1 = new JLabel("Input alphabet");
	String[] alphabets = { "a, b", "x, y", "a..z", "0, 1", "0..9", 
			       "1..10"};

	alphabets_in_ = new JComboBox(alphabets);
	alphabets_in_.addActionListener(this);

	JPanel pc = new JPanel(new GridLayout(1, 1));
	pc.add(alphabets_in_);

	JPanel p = new JPanel(new BorderLayout());
	p.add(label1, BorderLayout.NORTH);
	p.add(pc, BorderLayout.CENTER);
	
	return p;
    }

    protected JPanel		create_alphabet_out_panel()
    {
	JLabel label1 = new JLabel("Output alphabet");
	String[] alphabets = { "a, b", "x, y", "a..z", "0, 1", "0..9", 
			       "1..10"};

	alphabets_out_ = new JComboBox(alphabets);
	alphabets_out_.addActionListener(this);

	JPanel pc = new JPanel(new GridLayout(1, 1));
	pc.add(alphabets_out_);

	JPanel p = new JPanel(new BorderLayout());
	p.add(label1, BorderLayout.NORTH);
	p.add(pc, BorderLayout.CENTER);
	
	return p;
    }


    protected JPanel		create_weight_type_panel()
    {
	JLabel label1 = new JLabel("Weight");
	String[] weight = { "B", "Z", "R", "(Z,max,+)", "(Z,min,+)"};

	weight_ = new JComboBox(weight);
	weight_.addActionListener(this);

	JPanel pc = new JPanel(new GridLayout(1, 1));
	pc.add(weight_);

	JPanel p = new JPanel(new BorderLayout());
	p.add(label1, BorderLayout.NORTH);
	p.add(pc, BorderLayout.CENTER);
	
	return p;
    }



    public void			itemStateChanged(ItemEvent e) 
    {
    }

    protected void		set_automaton_mode()
    {
 	panel_alpha_out_.setVisible(false);
	alphabets_out_.setVisible(false);
    }

    protected void		set_transducer_mode()
    {
 	panel_alpha_out_.setVisible(true);
	alphabets_out_.setVisible(true);
    }


    public void			actionPerformed(ActionEvent e) 
    {
 	Object source = e.getSource();

 	if (source == bok_) 
	    {
		set_automaton_structure_properties();
		frame_hide();
	    }
	else if (source == bsave_)
	    set_automaton_structure_properties();
 	else if (source == bcancel_) 
 	    frame_hide();
	else if (source == types_)
	    {
		if (types_.getSelectedItem()
		    .equals(VJToolKitConstants.XML_AUTOMATON_TYPE_DEFAULT))
		    set_automaton_mode();
		else
		    set_transducer_mode();
	    }
    }


    public void			frame_show()
    {
  	get_automaton_structure_properties();
	if (types_.getSelectedItem()
	    .equals(VJToolKitConstants.XML_AUTOMATON_TYPE_DEFAULT))
	    set_automaton_mode();
	else
	    set_transducer_mode();
	super.frame_show();
    }



    protected void		get_automaton_structure_properties()
    {

	int idx = storage_.tabbed_pane_get().getSelectedIndex();
	Map m = (Map) ((VJGraph) storage_.graph_get(idx))
	    .automaton_structure_get();

	types_.setSelectedItem(m.get(VJToolKitConstants.XML_AUTOMATON_TYPE));
	alphabets_in_.setSelectedItem(m.get(VJToolKitConstants.XML_ALPHA_IN));
	alphabets_out_.setSelectedItem(m.get(VJToolKitConstants.XML_ALPHA_OUT));
	weight_.setSelectedItem(m.get(VJToolKitConstants.XML_WEIGHT));
	name_.setText(((VJGraph) storage_.graph_get(idx)).name_get());
    }


    protected void		set_automaton_structure_properties()
    {
	int idx = storage_.tabbed_pane_get().getSelectedIndex();
	Map m = (Map) ((VJGraph) storage_.graph_get(idx))
	    .automaton_structure_get();

	m.put(VJToolKitConstants.XML_AUTOMATON_TYPE, types_.getSelectedItem());
	m.put(VJToolKitConstants.XML_ALPHA_IN, 
		   alphabets_in_.getSelectedItem());
	m.put(VJToolKitConstants.XML_ALPHA_OUT, 
		   alphabets_out_.getSelectedItem());
	m.put(VJToolKitConstants.XML_WEIGHT, weight_.getSelectedItem());
	storage_.executable_set((String) types_.getSelectedItem(),
				(String) weight_.getSelectedItem());
	((VJGraph) storage_.graph_get(idx)).name_set(name_.getText());
	storage_.tabbed_pane_get().setTitleAt(idx, name_.getText());
    }
    

    // Attributes.
    protected JComboBox		types_;
    protected JComboBox		alphabets_in_;
    protected JComboBox		alphabets_out_;
    protected JComboBox		weight_;
    protected JPanel		panel_alpha_in_;
    protected JPanel		panel_alpha_out_;
    protected JTextField	name_;
}
