//
// CreateStateFrame.java for Vcsn in /home/loulou/enst/VcsnInterface
//
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
//
// Started on  Tue Dec 28 13:41:31 2004 Loulou Pouchet
// Last update Mon Jun 20 02:21:51 2005 Louis-Noel Pouchet
//

import vaucanson.vgitoolkit.*;


import javax.swing.JFrame;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class CreateStateFrame
    implements ActionListener
{
    public CreateStateFrame(Storage storage)
    {
	frame_ = new JFrame("State creation");
	storage_ = storage;
	storage_.create_state_frame_set(this);
	create_frame_elements();
    }


    public void			frame_show()
    {
	frame_.pack();
	frame_.setVisible(true);
	is_visible = true;
    }


    public void			frame_hide()
    {
	frame_.setVisible(false);
	is_visible = false;
    }



    // Buttons OK and Cancel are always present.
    protected JPanel		create_buttons()
    {
	// Buttons at bottom of the frame.
	bok_ = new JButton("OK");
	bcancel_ = new JButton("Close");
	bok_.addActionListener(this);
	bcancel_.addActionListener(this);
	JPanel panel_buttons = new JPanel(new GridLayout(1, 2));
	panel_buttons.add(bok_);
	panel_buttons.add(bcancel_);

	return panel_buttons;
    }


    protected JPanel		create_panel()
    {
	layout_circle_ = new JRadioButton("Circle layout");
	layout_quad_ = new JRadioButton("Quad layout");
	layout_line_ = new JRadioButton("Line layout");
	layout_line_.setSelected(true);

	circle_text_ = new JTextField();
 	circle_text_.setPreferredSize(new Dimension(30, 20));
	line_text_ = new JTextField();
 	line_text_.setPreferredSize(new Dimension(30, 20));
	quad_x_text_ = new JTextField();
 	quad_x_text_.setPreferredSize(new Dimension(30, 20));
	quad_y_text_ = new JTextField();
 	quad_y_text_.setPreferredSize(new Dimension(30, 20));

	layout_circle_.addActionListener(this);
	layout_quad_.addActionListener(this);
	layout_line_.addActionListener(this);

	group_ = new ButtonGroup();
	group_.add(layout_circle_);
	group_.add(layout_line_);
	group_.add(layout_quad_);

	JPanel panel = new JPanel(new GridLayout(3, 1));

	JPanel circle_panel = new JPanel(new BorderLayout());
	circle_panel.add(layout_circle_, BorderLayout.WEST);
	JPanel p1 = new JPanel(new FlowLayout());
	p1.add(new JLabel("States: "));
	p1.add(circle_text_);
	circle_panel.add(p1, BorderLayout.EAST);
	panel.add(circle_panel);

	JPanel line_panel = new JPanel(new BorderLayout());
	line_panel.add(layout_line_, BorderLayout.WEST);
	JPanel p2 = new JPanel(new FlowLayout());
	p2.add(new JLabel("States: "));
	p2.add(line_text_);
	line_panel.add(p2, BorderLayout.EAST);
	panel.add(line_panel);

	JPanel quad_panel = new JPanel(new BorderLayout());
	quad_panel.add(layout_quad_, BorderLayout.WEST);
	JPanel p3 = new JPanel(new FlowLayout());
	p3.add(new JLabel("States: "));
	p3.add(quad_x_text_);
	p3.add(new JLabel("Lines: "));
	p3.add(quad_y_text_);
	quad_panel.add(p3, BorderLayout.EAST);
	panel.add(quad_panel);

	return panel;
    }


    protected void		create_frame_elements()
    {
	Container content_pane = frame_.getContentPane();
	content_pane.setLayout(new BorderLayout());
        content_pane.add(create_panel(), BorderLayout.WEST);
 	content_pane.add(create_buttons(), BorderLayout.SOUTH);
    }


    public void			actionPerformed(ActionEvent e)
    {
 	Object source = e.getSource();

 	if (source == bok_)
	    {
		create_states();
		frame_hide();
	    }
 	else if (source == bcancel_)
 	    frame_hide();
    }


    protected void		create_states()
    {
	int			idx = 
	    storage_.tabbed_pane_get().getSelectedIndex();
	Object[]		cells;
	VJGraph			graph = storage_.graph_get(idx);
	LabelFactory		label_factory = 
	    storage_.label_factory_get(idx);
	String			name;

	if (layout_quad_.isSelected())
	    {
		try
		    {
			int x = Integer.parseInt(quad_x_text_.getText());
			int y = Integer.parseInt(quad_y_text_.getText());
			cells = new Object[x];
			for (int i = 0; i < x; ++i)
			    {
				name = label_factory.get_new_label();
				cells[i] = VJGraph.create_state(graph, name);
			    }
			QuadGraphLayout layout = new QuadGraphLayout();
			layout.apply(graph, cells, y);
		    }
		catch (java.lang.NumberFormatException e)
		    {

		    }
	    }
	else if (layout_line_.isSelected())
	    {
		try
		    {
			int x = Integer.parseInt(line_text_.getText());
			cells = new Object[x];
			for (int i = 0; i < x; ++i)
			    {
				name = label_factory.get_new_label();
				cells[i] = VJGraph.create_state(graph, name);
			    }
			QuadGraphLayout layout = new QuadGraphLayout();
			layout.apply(graph, cells, 1);
		    }
		catch (java.lang.NumberFormatException e)
		    {

		    }
	    }
	else if (layout_circle_.isSelected())
	    {
		try
		    {
			int x = Integer.parseInt(circle_text_.getText());
			cells = new Object[x];
			for (int i = 0; i < x; ++i)
			    {
				name = label_factory.get_new_label();
				cells[i] = VJGraph.create_state(graph, name);
			    }
			CircleGraphLayout layout = new CircleGraphLayout();
			layout.apply(graph, cells);
		    }
		catch (java.lang.NumberFormatException e)
		    {

		    }
	    }
    }



    protected Storage		storage_;
    protected JFrame		frame_;
    protected JButton		bok_;
    protected JButton		bcancel_;


    protected JTextField	line_text_;
    protected JTextField	circle_text_;
    protected JTextField	quad_x_text_;
    protected JTextField	quad_y_text_;

    protected JRadioButton	layout_circle_;
    protected JRadioButton	layout_quad_;
    protected JRadioButton	layout_line_;

    protected ButtonGroup	group_;

    public boolean		is_visible = false;
}
