//
// EditorCommands.java for Vcsn in /home/loulou/enst/VcsnInterface
//
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
//
// Started on  Fri Dec 10 17:11:58 2004 Loulou Pouchet
// Last update Mon Dec 11 20:54:32 2006 Guillaume
//

import vaucanson.vgitoolkit.*;


import org.jgraph.JGraph;
import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.graph.DefaultPort;

import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.util.Iterator;
import java.util.Map;
import java.util.Hashtable;

import java.awt.geom.Rectangle2D;

import org.xml.sax.SAXException;
// Java
import java.io.IOException;
import java.awt.Dimension;


import javax.swing.JScrollPane;


public class EditorCommands
{

    // Delete selection.
    public static void		delete(VJGraph graph,
				       LabelFactory lf)
    {
      if (! graph.isSelectionEmpty())
      {
	DefaultGraphModel model = (DefaultGraphModel) graph.getModel();
	Object[] cells = graph.getSelectionCells();
	ArrayList objects = new ArrayList();
	List l;
	for (int i = 0; i < cells.length; ++i)
	{
	  objects.add(cells[i]);
	  if (cells[i] instanceof State)
	  {
	    l = get_connected_edges(cells[i], model);
	    for (int j = 0; j < l.size(); ++j)
	      if (! objects.contains(l.get(j)))
		objects.add(l.get(j));
	    lf.delete_element(((State) (cells[i])).get_label());
	  }
	}
	graph.getModel().remove(objects.toArray());
      }
    }



    // Get edge connected to a cell. Generic method.
    public static List		get_connected_edges(Object cell,
						    DefaultGraphModel model)
    {
      DefaultEdge current;
      Set edges = model.getEdges(model, new Object[]{cell});
      Iterator iter = edges.iterator();
      ArrayList res = new ArrayList();
      while (iter.hasNext())
	res.add(iter.next());
      return (List) res;
    }


    // Update properties for the graph.
    public static void		set_properties(Object obj,
					       Map attributes,
					       JGraph graph)
    {
    }


    // Get properties for the graph.
    public static Map		get_properties(JGraph graph,
					       State s)
    {
      Map attrib = new Hashtable();
      DefaultGraphModel model = (DefaultGraphModel) graph.getModel();
      attrib.put(s, model.getAttributes(s));
      List l = get_connected_edges(s, model);
      for (int i = 0; i < l.size(); ++i)
      {
	Object obj = l.get(i);
	if (obj instanceof TerminalTransition)
	  attrib.put(obj, model.getAttributes(obj));
      }
      return attrib;
    }

    public static Map		get_properties(JGraph graph,
					       Transition t)
    {

      return (Map) graph.getModel().getAttributes(t);
    }

    public static void		set_initial(Storage storage)
    {
      int idx = storage.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage.graph_get(idx);
      if (! graph.isSelectionEmpty())
      {
	Object obj = graph.getSelectionCells()[0];
	if (obj instanceof State)
	  ((State) obj).set_initial("", null);
	else
	  Debug.echo("You must select 1 state");

      }
    }

    public static void		set_final(Storage storage)
    {
      int idx = storage.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage.graph_get(idx);
      if (! graph.isSelectionEmpty())
      {
	Object obj = graph.getSelectionCells()[0];
	if (obj instanceof State)
	  ((State) obj).set_final("", null);
	else
	  Debug.echo("You must select 1 state");
      }
    }


    // Entry point for properties management.
    public static void			properties(Storage storage)
    {
      int idx = storage.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage.graph_get(idx);
      if (! graph.isSelectionEmpty())
      {
	Object[] cells = graph.getSelectionCells();
	for (int i = 0; i < cells.length; ++i)
	{
	  Object obj = cells[i];
	  if (obj instanceof State)
	  {
	    storage.state_properties_get()
	      .frame_show((State) obj);
	  }
	  if (obj instanceof Transition)
	  {
	    storage.transition_properties_get()
	      .frame_show((Transition) obj);
	  }
	  if (obj instanceof TerminalTransition)
	  {
	    TerminalTransition t =
	      (TerminalTransition) obj;
	    DefaultPort p = (DefaultPort) t.getTarget();

	    storage.state_properties_get().frame_show
	      ((State) (p.getUserObject()));
	  }
	}
      }
    }


    public static void			connect(Storage storage)
    {
      int idx = storage.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage.graph_get(idx);

      if (! graph.isSelectionEmpty())
      {
	Object[] cells = graph.getSelectionCells();
	if (cells.length == 2
	    && cells[0] instanceof State
	    && cells[1] instanceof State)
	{
	  Transition t;
	  t = VJGraph.create_transition(graph,
					(State) cells[0],
					(State) cells[1]);
	  //graph.startEditingAtCell(t);
	}
	else if (cells.length == 1 && cells[0] instanceof State)
	{
	  Transition t;
	  t = VJGraph.create_transition(storage.graph_get(idx),
					(State) cells[0],
					(State) cells[0]);
	  //graph.startEditingAtCell(t);
	}
	else
	  Debug.echo("You must select 2 states.");
      }
      else
	Debug.echo("You must select 2 states.");
      ///////////////////////////////////////
      // 	Tools.refresh_view(graph);
      ///////////////////////////////////////

    }


    public static void			create_state(Storage storage)
    {
      storage.create_state_frame_get().frame_show();
    }

    public static void			create_state_at(Storage storage,
							int x, int y)
    {
      int idx = storage.tabbed_pane_get().getSelectedIndex();
      String name = storage.label_factory_get(idx).get_new_label();

      VJGraph graph = (VJGraph) storage.graph_get(idx);
      State s = VJGraph.create_state(graph, name);
      GeometryProperties.setX(s, x);
      GeometryProperties.setY(s, y);
      // 	storage.state_properties_get().frame_show(s);
      storage.label_factory_get(idx).update_label_factory(name);
      s.update();
    }


    public static void			order_states(Storage storage)
    {
      int idx = storage.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage.graph_get(idx);

      if (! graph.isSelectionEmpty())
      {
	Object[] cells = graph.getSelectionCells();

	for (int i = 0; i < cells.length; ++i)
	{
	  State ref = (State) cells[i];
	  ref.number_set(i);
	  Debug.echo("done");
	}
      }
      graph.clearSelection();
    }



    public static void			order_state_at(Storage storage,
						       int x, int y)
    {
      int idx = storage.tabbed_pane_get().getSelectedIndex();
      String name = storage.label_factory_get(idx).get_new_label();

      VJGraph graph = (VJGraph) storage.graph_get(idx);
      State s = VJGraph.create_state(graph, name);
      GeometryProperties.setX(s, x);
      GeometryProperties.setY(s, y);
      // 	storage.state_properties_get().frame_show(s);
      storage.label_factory_get(idx).update_label_factory(name);
      s.update();
    }


    public static void			edit_structure(Storage storage)
    {
      storage.automaton_structure_properties_get().frame_show();
    }



    public static VJGraph		create_graph(String filename,
						     Storage storage)
    {
      VJGraph graph = XMLReader.file_to_graph(filename);
      LabelFactory lb = new LabelFactory();
      lb.init_label_factory(graph);

      VJTools.init_jgraph_attributes(graph);

      // Store values.
      int idx = storage.filename_set(filename);
      storage.name_factory_get().update_label_factory(filename);
      storage.graph_set(graph);
      storage.label_factory_set(lb);

      if (graph.name_get() == "")
      {
	storage.name_set(storage.name_factory_get().get_new_label());
	graph.name_set(storage.name_get(idx));
      }
      else
	storage.name_set(graph.name_get());

      graph.setMinimumSize(new Dimension(VJToolKitConstants.WIDTH_GRAPH,
					 VJToolKitConstants.HEIGHT_GRAPH));

      // MouseListener that Prints the Cell on Doubleclick
      graph.addMouseListener(new EditorMouseAdapter(storage));

      // Add undo manager.
      graph.add_undo_manager();

      PopupMenu popup = new PopupMenu(storage);
      popup.create(graph);


      try
      {
	storage.tabbed_pane_get().addTab(graph.name_get(),
					 new JScrollPane(graph));
	storage.executable_set((String) graph.automaton_structure_get()
			       .get(VJToolKitConstants.XML_AUTOMATON_TYPE),
			       (String) graph.automaton_structure_get()
			       .get(VJToolKitConstants.XML_WEIGHT));
      }
      catch ( java.lang.NullPointerException E)
      {
	//Debug.echo("Incroyable...");
      }

      // Select the last opened tab.
      storage.tabbed_pane_get().setSelectedIndex
	(storage.tabbed_pane_get().getTabCount() - 1);
      Object[] sel = graph.getSelectionCells();
      for (int i = 0; i < sel.length; ++i)
	graph.removeSelectionCell(sel[i]);

      LayoutTemplate.apply_layout(graph, false);
      CenterGraphLayout l = new CenterGraphLayout();
      l.apply(graph, null);
      Tools.refresh_view(graph);
      return graph;
    }



    public static VJGraph	create_empty_graph(Storage storage)
    {
      DefaultGraphModel model = new DefaultGraphModel();

      VJGraph graph = new VJGraph(model);

      VJTools.init_jgraph_attributes(graph);

      // MouseListener that Prints the Cell on Doubleclick
      graph.addMouseListener(new EditorMouseAdapter(storage));

      // Add undo manager.
      graph.add_undo_manager();


      LabelFactory lb = new LabelFactory();
      lb.init_label_factory(graph);


      storage.graph_set(graph);
      int idx = storage.name_set(storage.name_factory_get()
				 .get_new_label());
      graph.name_set(storage.name_get(idx));
      storage.label_factory_set(lb);

      storage.filename_set(storage.name_get(idx) + ".xml");


      PopupMenu popup = new PopupMenu(storage);
      popup.create(graph);
      graph.setMinimumSize(new Dimension(VJToolKitConstants.WIDTH_GRAPH,
					 VJToolKitConstants.HEIGHT_GRAPH));

      storage.tabbed_pane_get().addTab(graph.name_get(),
				       new JScrollPane(graph));

      // Select the last opened tab.
      storage.tabbed_pane_get().setSelectedIndex
	(storage.tabbed_pane_get().getTabCount() - 1);
      return graph;
    }


    public static void				zoom_up(VJGraph graph)
    {
      double scale = graph.getScale() + 0.2;
      graph.setScale(scale);
      graph.setGridSize(VJToolKitConstants.PIXEL_PER_CM * scale);
      Tools.refresh_view(graph);
    }

    public static void				zoom_down(VJGraph graph)
    {
      double scale = graph.getScale() - 0.2;
      graph.setScale(scale);
      graph.setGridSize(VJToolKitConstants.PIXEL_PER_CM * scale);
      Tools.refresh_view(graph);
    }



}
