//
// EditorToolbar.java for Vcsn in /home/loulou/enst/VcsnInterface
//
// Made by Louis-Noel Pouchet
// Login   <loulou@lrde.epita.fr>
//
// Started on  Wed Dec 15 01:46:32 2004 Louis-Noel Pouchet
// Last update Tue Jan 25 01:01:13 2005 Louis-Noel Pouchet
//

import vaucanson.vgitoolkit.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;


public class EditorToolbar extends JPanel
{
    protected JToolBar toolBar;

    protected Storage storage_;

    public EditorToolbar(Storage storage)
    {
	storage_ = storage;
    }


    public JToolBar	create_toolbar()
    {
        // Create a set of actions to use in both the menu and toolbar.
        ToolbarAction sel = new ToolbarAction("Sel", new ImageIcon("left.gif"),
					      "Select", 'S');
        ToolbarAction add = new ToolbarAction("Add st", new ImageIcon("left.gif"),
					      "Add state", 'A');
        ToolbarAction conn = new ToolbarAction("Conn",  new ImageIcon("right.gif"),
					       "Connect two states", 'C');
        ToolbarAction del = new ToolbarAction("Del", new ImageIcon("center.gif"),
					      "Delete selection", 'D');
        ToolbarAction prop = new ToolbarAction("Prop",  new ImageIcon("full.gif"),
					       "Properties", 'P');
        ToolbarAction close = new ToolbarAction("Close",new ImageIcon("full.gif"),
						"Close current graph", 'X');
        ToolbarAction create = new ToolbarAction("New", new ImageIcon("full.gif"),
						 "Create new graph", 'N');


	toolBar = new JToolBar();
	toolBar.add(sel);
	toolBar.add(add);
	toolBar.add(conn);
	toolBar.add(del);
	toolBar.add(prop);
	toolBar.add(close);
	toolBar.add(create);

	return toolBar;
    }


    class ToolbarAction extends AbstractAction
    {

        public ToolbarAction(String text, Icon icon,
			     String description, char accelerator)
	{
	    //             super(text, icon);
            super(text);
            putValue(ACCELERATOR_KEY,
		     KeyStroke.getKeyStroke(accelerator,
					    Toolkit.getDefaultToolkit()
					    .getMenuShortcutKeyMask()));
            putValue(SHORT_DESCRIPTION, description);
        }

        public void actionPerformed(ActionEvent e)
	{
	    // Exiting create mode.
	    storage_.mode_set(VJToolKitConstants.MODE_SELECT);

	    int idx = storage_.tabbed_pane_get().getSelectedIndex();
	    String orig = (String) getValue(NAME);
            try
	    {
		if (orig.equals("Del"))
		    EditorCommands.delete(storage_.graph_get(idx),
					  storage_.label_factory_get
					  (idx));
		if (orig.equals("Prop"))
		    EditorCommands.properties(storage_);
		if (orig.equals("Conn"))
		    EditorCommands.connect(storage_);
		if (orig.equals("Add st"))
		    storage_.mode_set(VJToolKitConstants.MODE_CREATE);
		if (orig.equals("Sel"))
		    storage_.mode_set(VJToolKitConstants.MODE_SELECT);
		if (orig.equals("Close"))
		    if (idx != -1)
		    {
			storage_.tabbed_pane_get().remove(idx);
			storage_.remove_automaton(idx);
		    }
		if (orig.equals("New"))
		    EditorCommands.create_empty_graph(storage_);
	    }
	    catch (Exception ex)
	    {
		ex.printStackTrace();
	    }
        }
    }


}
