//
// MenuBar.java for Vcsn in /home/loulou/enst/VcsnInterface
//
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
//
// Started on  Fri Dec 10 11:54:32 2004 Loulou Pouchet
// Last update Tue Dec  5 16:22:21 2006 Guillaume
//

import vaucanson.vgitoolkit.*;


import org.jgraph.graph.*;
import org.jgraph.util.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;
import javax.swing.JMenuBar;
import javax.swing.KeyStroke;
import javax.swing.ImageIcon;

import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFrame;

import javax.swing.filechooser.*;
import java.io.*;
import javax.swing.*;

import java.util.Map;


import javax.swing.*;
import java.beans.*; //Property change stuff


public class MenuBar implements ActionListener, ItemListener
{

    public MenuBar()
    {
      super();
      fc_ = new JFileChooser(System.getProperties().getProperty("user.dir"));
    }


    public MenuBar(Storage storage)
    {
      super();
      storage_ = storage;
      fc_ = new JFileChooser(System.getProperties().getProperty("user.dir"));
    }


    // Create application menu.
    public JMenuBar		create_menu_bar()
    {
      JMenuBar		menu_bar;

      //Create the menu bar.
      menu_bar = new JMenuBar();

      menu_bar.add(create_file_menu());
      menu_bar.add(create_edit_menu());
      menu_bar.add(create_view_menu());
      menu_bar.add(create_algorithms_menu());

      return menu_bar;
    }


    public JMenu		create_file_menu()
    {
      //Build the File menu.
      JMenu menu = new JMenu("File");
      menu.setMnemonic(KeyEvent.VK_F);
      menu.getAccessibleContext().setAccessibleDescription("File menu");

      // New
      JMenuItem item = new JMenuItem("New", KeyEvent.VK_N);
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("New XML automaton file.");
      item.addActionListener(this);
      menu.add(item);

      // Open...
      item = new JMenuItem("Open...", KeyEvent.VK_O);
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Open XML automaton file.");
      item.addActionListener(this);
      menu.add(item);


      // Close
      item = new JMenuItem("Close", KeyEvent.VK_C);
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Close current XML automaton.");
      item.addActionListener(this);
      menu.add(item);


      // Save
      item = new JMenuItem("Save", KeyEvent.VK_S);
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Save XML automaton file.");
      item.addActionListener(this);
      menu.add(item);

      // Save as...
      item = new JMenuItem("Save as...", KeyEvent.VK_A);
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Save to other XML automaton file.");
      item.addActionListener(this);
      menu.add(item);


      // - - - -
      menu.addSeparator();

      // Exit
      item = new JMenuItem("Exit", KeyEvent.VK_E);
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Exit editor.");
      item.addActionListener(this);
      menu.add(item);

      return menu;
    }


    public JMenu		create_edit_menu()
    {
      JMenu menu = new JMenu("Edit");
      menu.setMnemonic(KeyEvent.VK_E);
      menu.getAccessibleContext()
	.setAccessibleDescription("Edition menu.");

      // Undo
      JMenuItem item = new JMenuItem("Undo");
      // item.setMnemonic(KeyEvent.VK_T);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Undo selection.");
      item.addActionListener(this);
      menu.add(item);


      // Redo
      item = new JMenuItem("Redo");
      // item.setMnemonic(KeyEvent.VK_T);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Redo last action.");
      item.addActionListener(this);
      menu.add(item);

      // - - - -
      menu.addSeparator();

      // Delete
      item = new JMenuItem("Delete");
      // item.setMnemonic(KeyEvent.VK_T);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Delete selection.");
      item.addActionListener(this);
      menu.add(item);

      // Properties
      item = new JMenuItem("Properties");
      // item.setMnemonic(KeyEvent.VK_T);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Get selection properties.");
      item.addActionListener(this);
      menu.add(item);

      // Connect
      item = new JMenuItem("Connect");
      // item.setMnemonic(KeyEvent.VK_T);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Connect two states.");
      item.addActionListener(this);
      menu.add(item);

      // Create state
      item = new JMenuItem("Create state");
      item.setMnemonic(KeyEvent.VK_C);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Create new states");
      item.addActionListener(this);
      menu.add(item);

      // Order states
      item = new JMenuItem("Order states");
      item.setMnemonic(KeyEvent.VK_C);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Put an ordering on states");
      item.addActionListener(this);
      menu.add(item);


      // - - - -
      menu.addSeparator();

      // Automaton structure.
      item = new JMenuItem("Automaton structure");
      // item.setMnemonic(KeyEvent.VK_T);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Edit automaton structure");
      item.addActionListener(this);
      menu.add(item);

      // View XML output.
      item = new JMenuItem("View XML output");
      // item.setMnemonic(KeyEvent.VK_T);
      // item.setAccelerator(KeyStroke.getKeyStroke
      //	  	      (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("View XML output");
      item.addActionListener(this);
      menu.add(item);

      return menu;
    }


    public JMenu		create_view_menu()
    {
      //Build the View menu.
      JMenu menu = new JMenu("View");
      menu.setMnemonic(KeyEvent.VK_V);
      menu.getAccessibleContext().setAccessibleDescription("View menu");

      // Refresh view.
      JMenuItem item = new JMenuItem("Refresh view");
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Refresh view.");
      item.addActionListener(this);
      menu.add(item);

      // Center graph.
      item = new JMenuItem("Center graph");
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Center graph.");
      item.addActionListener(this);
      menu.add(item);

      // Zoom
      item = new JMenuItem("Zoom +");
      item.addActionListener(this);
      menu.add(item);

      item = new JMenuItem("Zoom -");
      item.addActionListener(this);
      menu.add(item);

      JMenu submenu = new JMenu("Layout");

      // Apply global layout
      item = new JMenuItem("Apply global layout");
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Apply global layout on selected cells.");
      item.addActionListener(this);
      submenu.add(item);

      // Apply Simulated Annealing
      item = new JMenuItem("Apply SA");
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Apply Simulated Annealing on selected cells.");
      item.addActionListener(this);
      submenu.add(item);

      // Apply circle layout
      item = new JMenuItem("Apply circle layout");
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Apply circle layout on selected cells.");
      item.addActionListener(this);
      submenu.add(item);

      // Apply line layout
      item = new JMenuItem("Apply line layout");
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Apply line layout on selected cells.");
      item.addActionListener(this);
      submenu.add(item);

      // Apply quad layout
      item = new JMenuItem("Apply quad layout");
      // 	item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1,
      // 						       ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Apply quad layout on selected cells.");
      item.addActionListener(this);
      submenu.add(item);


      menu.add(submenu);

      return menu;
    }

    protected JMenuItem		create_menu_item(String name, String desc)
    {
      JMenuItem item = new JMenuItem(name);
      //  	item.setMnemonic(KeyEvent.VK_T);
      // 	item.setAccelerator(KeyStroke.getKeyStroke
      // 			    (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription(desc);
      item.addActionListener(this);
      return item;
    }


    //Build the Algorithms menu.

    /// FIXME: The test here should determine if this is an applet or not,
    /// and if it is, don't display algorithm menu. Better, it should
    /// only be displayed if Vaucanson is present. See compilations with
    /// definitions on javac.
    public JMenu		create_algorithms_menu()
    {
      JMenu menu = new JMenu("Algorithms");
      menu.setMnemonic(KeyEvent.VK_A);
      menu.getAccessibleContext()
	.setAccessibleDescription("Algorithms menu.");

      JMenu b_submenu = new JMenu("Boolean automaton");
      JMenu k_submenu = new JMenu("Weighted automaton");
      JMenu fmp_submenu = new JMenu("FMP transducer");
      JMenu rt_submenu = new JMenu("Realtime transducer");

      b_submenu.add(create_menu_item("determinize", "Determinization"));
      b_submenu.add(create_menu_item("minimize", "Minimization"));
      b_submenu.add(create_menu_item("trim", "Trim"));

      b_submenu.add(create_menu_item("standard of...", "Standard of..."));
      b_submenu.add(create_menu_item("thompson of...", "Thompson of..."));
      b_submenu.add(create_menu_item("derived terms", "derived terms"));
      b_submenu.add(create_menu_item("automaton to expression",
				     "Automaton to expression"));
      b_submenu.add(create_menu_item("quotient", "Quotient"));
      b_submenu.add(create_menu_item("eps-removal",
				     "Remove epsilon transitions"));
      b_submenu.add(create_menu_item("transpose", "Transpose"));
      b_submenu.add(create_menu_item("eval", "Eval"));
      b_submenu.add(create_menu_item("product", "Product"));
      b_submenu.add(create_menu_item("power", "Power"));

      k_submenu.add(create_menu_item("trim", "Trim"));
      k_submenu.add(create_menu_item("standard of...", "Standard of..."));
      k_submenu.add(create_menu_item("thompson of...", "Thompson of..."));
      k_submenu.add(create_menu_item("derived-term", "derived terms"));
      k_submenu.add(create_menu_item("automaton to expression",
				     "Automaton to expression"));
      k_submenu.add(create_menu_item("quotient", "Quotient"));
      k_submenu.add(create_menu_item("closure", "Closure"));
      k_submenu.add(create_menu_item("transpose", "Transpose"));
      k_submenu.add(create_menu_item("eval", "Eval"));
      k_submenu.add(create_menu_item("product", "Product"));
      k_submenu.add(create_menu_item("power", "Power"));

      fmp_submenu.add(create_menu_item("trim", "Trim"));
      fmp_submenu.add(create_menu_item("transpose", "Transpose"));
      fmp_submenu.add(create_menu_item("evaluation", "Evaluation"));
      fmp_submenu.add(create_menu_item("compose", "Compose"));
      fmp_submenu.add(create_menu_item("composition-cover",
				       "Composition cover"));
      fmp_submenu.add(create_menu_item("sub-normalize", "sub-normalize"));
      fmp_submenu.add(create_menu_item("is-sub-normalized",
				       "is-sub-normalized"));
      fmp_submenu.add(create_menu_item("is-empty", "is-empty"));
      fmp_submenu.add(create_menu_item("domain", "domain"));
      fmp_submenu.add(create_menu_item("image", "image"));
      fmp_submenu.add(create_menu_item("composition-cover",
				       "composition-cover"));
      fmp_submenu.add(create_menu_item("composition-co-cover",
				       "composition-co-cover"));
      fmp_submenu.add(create_menu_item("to-rt", "to-rt"));
      fmp_submenu.add(create_menu_item("intersection", "intersection"));


      rt_submenu.add(create_menu_item("trim", "Trim"));
      rt_submenu.add(create_menu_item("closure", "Closure"));
      rt_submenu.add(create_menu_item("transpose", "Transpose"));
      rt_submenu.add(create_menu_item("evaluation", "Evaluation"));
      rt_submenu.add(create_menu_item("compose", "Compose"));
      rt_submenu.add(create_menu_item("realtime", "realtime"));
      rt_submenu.add(create_menu_item("is-realtime", "is-realtime"));
      rt_submenu.add(create_menu_item("is-empty", "is-empty"));
      rt_submenu.add(create_menu_item("domain", "domain"));
      rt_submenu.add(create_menu_item("image", "image"));
      rt_submenu.add(create_menu_item("to-tdc", "to-tdc"));


      menu.add(b_submenu);
      menu.add(k_submenu);
      menu.add(fmp_submenu);
      menu.add(rt_submenu);

      // - - - -
      menu.addSeparator();

      // Used defined...
      JMenu submenu = new JMenu("User defined...");
      // 	menu.setMnemonic(KeyEvent.VK_A);
      submenu.getAccessibleContext()
	.setAccessibleDescription("User defined program");

      // Choose program
      JMenuItem item = new JMenuItem("Choose program...");
      // 	item.setAccelerator(KeyStroke.getKeyStroke
      // 			    (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Choose program");
      item.addActionListener(this);
      submenu.add(item);

      // Launch algorithm
      item = new JMenuItem("Launch algorithm");
      // 	item.setAccelerator(KeyStroke.getKeyStroke
      // 			    (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Launch algorithm");
      item.addActionListener(this);
      submenu.add(item);

      // Set command line arguments
      item = new JMenuItem("Set command line arguments");
      // 	item.setAccelerator(KeyStroke.getKeyStroke
      // 			    (KeyEvent.VK_1, ActionEvent.ALT_MASK));
      item.getAccessibleContext()
	.setAccessibleDescription("Set command line arguments");
      item.addActionListener(this);
      submenu.add(item);

      menu.add(submenu);

      return menu;
    }

    private void		set_executable()
    {
      int			idx =
	storage_.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage_.graph_get(idx);
      storage_.executable_set((String) graph.automaton_structure_get()
			      .get(VJToolKitConstants.XML_AUTOMATON_TYPE),
			      (String) graph.automaton_structure_get()
			      .get(VJToolKitConstants.XML_WEIGHT));

    }


    public void			launch_no_arg_algorithm(String name)
    {
      set_executable();
      int			idx =
	storage_.tabbed_pane_get().getSelectedIndex();
      VJGraph out = EditorCommands.create_empty_graph(storage_);
      IO.launch_algorithm
	(new String[]{storage_.executable_get(), name},
	 storage_.graph_get(idx), out);
    }

    public void			launch_two_arg_algorithm(String name,
							 String arg1)
    {
      set_executable();
      int			idx =
	storage_.tabbed_pane_get().getSelectedIndex();
      VJGraph out = EditorCommands.create_empty_graph(storage_);
      if (arg1 == null || arg1.equals(""))
	IO.launch_algorithm
	  (new String[]{storage_.executable_get(), name},
	   storage_.graph_get(idx), out);
      else
	IO.launch_algorithm
	  (new String[]{storage_.executable_get(), name, arg1},
	   storage_.graph_get(idx), out);
    }


    public void			launch_one_arg_algorithm(String name,
							 String arg1)
    {
      set_executable();
      int			idx =
	storage_.tabbed_pane_get().getSelectedIndex();
      VJGraph out = EditorCommands.create_empty_graph(storage_);
      if (arg1 == null || arg1.equals(""))
	IO.launch_rat_algorithm
	  (new String[]{storage_.executable_get(),
			storage_.alphabet_get(), name}, out);
      else
	IO.launch_rat_algorithm
	  (new String[]{storage_.executable_get(),
			storage_.alphabet_get(), name, arg1}, out);
    }


    public String		launch_return_algorithm(String name,
							String arg1)
    {
      set_executable();
      int			idx =
	storage_.tabbed_pane_get().getSelectedIndex();
      if (arg1 == null || arg1.equals(""))
	return IO.launch_algorithm
	  (new String[]{storage_.executable_get(), name},
	   storage_.graph_get(idx));
      else
	return IO.launch_algorithm
	  (new String[]{storage_.executable_get(), name, arg1},
	   storage_.graph_get(idx));
    }


    // Dispatch menu events.
    public void			actionPerformed(ActionEvent e)
    {
      // Exiting create mode.
      storage_.mode_set(VJToolKitConstants.MODE_SELECT);

      JMenuItem		source = (JMenuItem)(e.getSource());
      String			orig = source.getText();
      int			idx =
	storage_.tabbed_pane_get().getSelectedIndex();
      String val;

      // File menu.
      if (orig.equals("New"))
	file_new();
      if (orig.equals("Open..."))
	file_open();
      if (orig.equals("Close"))
	file_close();
      if (orig.equals("Save"))
	file_save();
      if (orig.equals("Save as..."))
	file_save_as();
      if (orig.equals("Exit"))
	file_exit();

      // Algorithms menu.
      // Standard calls.
      if (orig.equals("determinize") || orig.equals("quotient") ||
	  orig.equals("trim") || orig.equals("quotient") ||
	  orig.equals("eps-removal") || orig.equals("transpose")
	  || orig.equals("sub-normalize")
	  || orig.equals("domain")
	  || orig.equals("image")
	  || orig.equals("composition-cover")
	  || orig.equals("composition-co-cover")
	  || orig.equals("to-rt")
	  || orig.equals("intersection")
	  || orig.equals("realtime")
	  || orig.equals("is-realtime")
	  || orig.equals("to-tdc"))
	launch_no_arg_algorithm(orig);

      // Return-value calls
      if (orig.equals("is-sub-normalized") || orig.equals("is-empty"))
	show_output_dlg("Returned value: ",
			launch_return_algorithm(orig, null));

      // Special calls
      if (orig.equals("standard of..."))
      {
	val = show_input_dlg("Enter an expression");
	if (val != null && ! val.equals(""))
	  launch_one_arg_algorithm("standard", val);
      }
      if (orig.equals("thompson of..."))
      {
	val = show_input_dlg("Enter an expression");
	if (val != null && ! val.equals(""))
	  launch_one_arg_algorithm("thompson", val);
      }
      if (orig.equals("power"))
      {
	val = show_input_dlg("Enter power");
	if (val != null && ! val.equals(""))
	  launch_two_arg_algorithm("power", val);
      }
      if (orig.equals("derived terms"))
      {
	val = show_input_dlg("Enter an expression");
	if (val != null && ! val.equals(""))
	  launch_one_arg_algorithm("derived-term", val);
      }
      if (orig.equals("automaton to expression"))
	show_output_dlg("Corresponding expression is: ",
			launch_return_algorithm("aut-to-exp", null));
      if (orig.equals("eval"))
      {
	val = show_input_dlg("Enter a word to evaluate");
	if (val != null && ! val.equals(""))
	  show_output_dlg("Evaluation is: ",
			  launch_return_algorithm
			  ("eval", val));
      }

      if (orig.equals("evaluation"))
      {
	val = show_input_dlg("Enter an expression to evaluate");
	if (val != null && ! val.equals(""))
	  show_output_dlg("Evaluation is: ",
			  launch_return_algorithm
			  ("evaluation", val));
      }

      if (orig.equals("product") || orig.equals("compose"))
      {
	String a1 = show_automaton_sel_dlg("Automaton #1");
	String a2 = show_automaton_sel_dlg("Automaton #2");

	VJGraph out = EditorCommands.create_empty_graph(storage_);

	IO.launch_algorithm
	  (new String[]{storage_.executable_get(), orig},
	   storage_.graph_get(storage_.filename_get_idx(a1)),
	   storage_.graph_get(storage_.filename_get_idx(a2)),
	   out);
      }

      if (orig.equals("Choose program..."))
	algorithms_user_defined_choose();
      if (orig.equals("Launch algorithm"))
	algorithms_user_defined_launch();
      if (orig.equals("Set command line arguments"))
	algorithms_set_command_line_arguments();

      // View menu.
      if (orig.equals("Refresh view"))
	Tools.refresh_view(storage_.graph_get(idx));
      if (orig.equals("Center graph"))
	view_center_layout();
      if (orig.equals("Apply global layout"))
	view_global_layout();
      if (orig.equals("Apply SA"))
	view_sa_layout();
      if (orig.equals("Apply circle layout"))
	view_circle_layout();
      if (orig.equals("Apply line layout"))
	view_line_layout();
      if (orig.equals("Apply quad layout"))
	view_quad_layout();
      if (orig.equals("Zoom +"))
	EditorCommands.zoom_up(storage_.graph_get(idx));
      if (orig.equals("Zoom -"))
	EditorCommands.zoom_down(storage_.graph_get(idx));

      // 	if (orig.equals("Apply global layout"))
      // 	    LayoutTemplate.apply_layout(storage_.graph_get(idx), true);

      // Edit menu.
      if (orig.equals("Undo"))
	try
	{
	  storage_.graph_get(idx).undo_manager_get().undo();
	}
	catch (javax.swing.undo.CannotUndoException e1)
	{
	  Debug.echo("Undo raised an exception");
	}
      if (orig.equals("Redo"))
	try
	{
	  storage_.graph_get(idx).undo_manager_get().redo();
	}
	catch (javax.swing.undo.CannotRedoException e2)
	{
	  Debug.echo("Redo raised an exception");
	}
      if (orig.equals("Delete"))
	EditorCommands.delete(storage_.graph_get(idx),
			      storage_.label_factory_get(idx));
      if (orig.equals("Properties"))
	EditorCommands.properties(storage_);
      if (orig.equals("Connect"))
	EditorCommands.connect(storage_);
      if (orig.equals("Create states"))
	EditorCommands.create_state(storage_);
      if (orig.equals("Order states"))
	EditorCommands.order_states(storage_);
      if (orig.equals("Automaton structure"))
	EditorCommands.edit_structure(storage_);
      if (orig.equals("View XML output"))
      {
	String b = XMLWriter.graph_to_string(storage_.graph_get(idx));
	show_output_only_dlg("XML output", b);
      }
    }


    public void		view_global_layout()
    {
      int idx = storage_.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage_.graph_get(idx);
      // 	GlobalLayout layout = new GlobalLayout();
      // 	Object[] sel = VJGraph.get_selection(graph);

      // 	if (sel.length != 0)
      // 	    layout.apply(graph, sel);
      // 	else
      // 	    layout.apply(graph, DefaultGraphModel.getAll(graph.getModel()));
      LayoutTemplate.apply_global_layout(graph);
    }


    public void		view_sa_layout()
    {
      int idx = storage_.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage_.graph_get(idx);
      SALayout layout = new SALayout();
      Object[] sel = VJGraph.get_selection(graph);

      if (sel.length != 0)
	layout.apply(graph, sel);
      else
	layout.apply(graph, DefaultGraphModel.getAll(graph.getModel()));
    }

    public void		view_center_layout()
    {
      int idx = storage_.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage_.graph_get(idx);
      CenterGraphLayout layout = new CenterGraphLayout();

      layout.apply(graph, DefaultGraphModel.getAll(graph.getModel()));
    }


    public void		view_circle_layout()
    {
      String s = (String)JOptionPane
	.showInputDialog(storage_.frame_get(),
			 "Type radius or leave to Automatic",
			 "Circle layout parameters",
			 JOptionPane.PLAIN_MESSAGE,
			 null,
			 null,
			 "Automatic");

      int idx = storage_.tabbed_pane_get().getSelectedIndex();
      CircleGraphLayout layout = new CircleGraphLayout();
      VJGraph graph = storage_.graph_get(idx);
      Object[] sel = VJGraph.get_selection(graph);

      if (s.equals("Automatic"))
      {
	if (sel.length != 0)
	  layout.apply(graph, sel);
	else
	  layout.apply(graph,
		       DefaultGraphModel.getAll(graph.getModel()));
      }
      else
	try
	{
	  int x = Integer.parseInt(s);
	  if (sel.length != 0)
	    layout.apply(graph, sel, x);
	  else
	    layout.apply(graph, DefaultGraphModel
			 .getAll(graph.getModel()), x);
	}
	catch (java.lang.NumberFormatException e)
	{
	  Debug.echo("Bad number format");
	}
    }


    public void		view_line_layout()
    {
      int idx = storage_.tabbed_pane_get().getSelectedIndex();
      VJGraph graph = storage_.graph_get(idx);
      QuadGraphLayout layout = new QuadGraphLayout();

      Object[] sel = VJGraph.get_selection(graph);
      if (sel.length != 0)
	layout.apply(graph, sel, 1);
      else
	layout.apply(graph, DefaultGraphModel.getAll(graph.getModel()), 1);
    }


    public void		view_quad_layout()
    {
      String s = (String)JOptionPane
	.showInputDialog(storage_.frame_get(),
			 "Type the number of rows or leave to Automatic",
			 "Quad layout parameters",
			 JOptionPane.PLAIN_MESSAGE,
			 null,
			 null,
			 "Automatic");

      int idx = storage_.tabbed_pane_get().getSelectedIndex();
      QuadGraphLayout layout = new QuadGraphLayout();
      VJGraph graph = storage_.graph_get(idx);
      Object[] sel = VJGraph.get_selection(graph);

      if (s.equals("Automatic"))
      {
	if (sel.length != 0)
	  layout.apply(graph, sel);
	else
	  layout.apply(graph,
		       DefaultGraphModel.getAll(graph.getModel()));
      }
      else
	try
	{
	  int x = Integer.parseInt(s);
	  if (sel.length != 0)
	    layout.apply(graph, sel, x);
	  else
	    layout.apply(graph, DefaultGraphModel
			 .getAll(graph.getModel()), x);
	}
	catch (java.lang.NumberFormatException e)
	{
	}
    }



    // Handling File -> New
    public void			file_new()
    {
      EditorCommands.create_empty_graph(storage_);
    }


    // Handling File -> Open...
    public void			file_open()
    {
      fc_.setDialogTitle("Open Vaucanson XML file");
      int			ret = fc_.showOpenDialog(storage_.frame_get());

      if (ret == JFileChooser.APPROVE_OPTION)
      {
	String filename = ((File) fc_.getSelectedFile()).getPath();
	EditorCommands.create_graph(filename, storage_);
      }
    }

    // Handling File -> Close
    public void			file_close()
    {
      int idx = storage_.tabbed_pane_get().getSelectedIndex();

      if (idx != -1)
      {
	storage_.tabbed_pane_get().remove(idx);
	storage_.remove_automaton(idx);
      }
    }


    // Handling File -> Save.
    public void			file_save()
    {
      int			idx =
	storage_.tabbed_pane_get().getSelectedIndex();
      String			filename = storage_.filename_get(idx);
      // Ne pas decommenter
      // 	if (filename.equals("vaucanson_xml_" + idx + ".xml"))
      // 	    {
      // 		fc_.setDialogTitle("Save Vaucanson XML file to...");
      // 		int ret = fc_.showSaveDialog(storage_.frame_get());
      // 		if (ret == JFileChooser.APPROVE_OPTION)
      // 		    filename = ((File) fc_.getSelectedFile()).getPath();
      // 		else
      // 		    return;
      // 	    }


      XMLWriter.graph_to_file(storage_.graph_get(idx), filename);
      storage_.filename_set(filename, idx);
    }


    // Handling File -> Save as...
    public void			file_save_as()
    {
      fc_.setDialogTitle("Save Vaucanson XML file to...");

      int			ret = fc_.showSaveDialog(storage_.frame_get());

      if (ret == JFileChooser.APPROVE_OPTION)
      {
	String filename = ((File) fc_.getSelectedFile()).getPath();
	int idx = storage_.tabbed_pane_get().getSelectedIndex();
	XMLWriter.graph_to_file(storage_.graph_get(idx), filename);
	storage_.filename_set(filename, idx);
      }
    }


    // Handling File -> Exit.
    public void			file_exit()
    {
      System.exit(0);
    }


    // Handling Algorithms -> User defined... -> Choose
    public void			algorithms_user_defined_choose()
    {
      fc_.setDialogTitle("Choose Vaucanson C++ / XML algorithm program");

      int			ret = fc_.showOpenDialog(storage_.frame_get());

      if (ret == JFileChooser.APPROVE_OPTION)
	user_defined_filename_ = ((File) fc_.getSelectedFile()).getPath();
    }


    // Handling Algorithms -> User defined... -> Launch
    /// FIXME: Handle errors here.
    public void			algorithms_user_defined_launch()
    {
      int idx = storage_.tabbed_pane_get().getSelectedIndex();
      if (user_defined_filename_ != null)
	IO.launch_algorithm
	  (new String[]{user_defined_filename_,
			user_defined_command_args_},
	    storage_.graph_get(idx), storage_.graph_get(idx));
      else
	Debug.echo("user_defined_filename_ not defined");
    }


    //
    public void			algorithms_set_command_line_arguments()
    {
      user_defined_command_args_ =
	(String)JOptionPane
	.showInputDialog(storage_.frame_get(),
			 "Type the command line arguments",
			 "User defined algorithms",
			 JOptionPane.PLAIN_MESSAGE,
			 null,
			 null,
			 "");
    }


    //
    public String		show_automaton_sel_dlg(String message)
    {
      JFrame frame = storage_.frame_get();
      String[] automata = new String[storage_.graph_count];
      for (int i = 0; i < storage_.graph_count; ++i)
	automata[i] = storage_.filename_get(i);

      String out = (String) JOptionPane
	.showInputDialog(frame,
			 message,
			 "Automata selection",
			 JOptionPane.PLAIN_MESSAGE,
			 null,
			 automata,
			 storage_.filename_get(0));
      return out;
    }


    //
    public String		show_input_dlg(String message)
    {
      JFrame frame = storage_.frame_get();
      String out = (String) JOptionPane
	.showInputDialog(frame,
			 message,
			 "Input a value",
			 JOptionPane.PLAIN_MESSAGE,
			 null,
			 null,
			 "");
      if (message.equals("Enter an expression"))
	storage_.alphabet_set(out);
      return out;
    }


    //
    public void			show_output_dlg(String message,
						String value)
    {
      JTextArea text = storage_.text_get();

      text.append(message + value);
    }


    //
    public void			show_output_only_dlg(String message,
						     String value)
    {
      JTextArea text = storage_.text_get();

      text.setText("");
      text.append(message + value);
    }


    // Needed by ItemListener
    public void itemStateChanged(ItemEvent e) { }


    // Attributes.
    protected Storage		storage_;
    protected JFileChooser	fc_;
    protected String		user_defined_filename_;
    protected String		user_defined_command_args_ = null;
}
