//
// PopupMenu.java for Vcsn in /home/loulou/enst/VcsnInterface
// 
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
// 
// Started on  Fri Dec 10 16:49:17 2004 Loulou Pouchet
// Last update Sun Jun 19 02:19:39 2005 Louis-Noel Pouchet
//

import vaucanson.vgitoolkit.*;


import org.jgraph.JGraph;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JPopupMenu;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;
import javax.swing.JMenuBar;
import javax.swing.KeyStroke;
import javax.swing.ImageIcon;

import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFrame;


public class PopupMenu implements ActionListener
{
    public PopupMenu(Storage storage)
    {
	super();
	storage_ = storage;
    }


    // Create default popup.
    public void		create(JGraph obj) 
    {
        JMenuItem menuItem;

        //Create the popup menu.
        JPopupMenu popup = new JPopupMenu();
        menuItem = new JMenuItem("Delete");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Properties");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Connect");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Set initial");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Set final");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Create state");
        menuItem.addActionListener(this);
        popup.add(menuItem);

        //Add listener to the text area so the popup menu can come up.
        MouseListener popupListener = new PopupListener(popup);
        obj.addMouseListener(popupListener);
    }


    public void		actionPerformed(ActionEvent e) 
    { 
	int idx = storage_.tabbed_pane_get().getSelectedIndex();
	String source = ((JMenuItem) e.getSource()).getText();
	
	if (source.equals("Delete"))
	    EditorCommands.delete(storage_.graph_get(idx),
				  storage_.label_factory_get(idx));
	if (source.equals("Properties"))
	    EditorCommands.properties(storage_);
	if (source.equals("Connect"))
	    EditorCommands.connect(storage_);
	if (source.equals("Create state"))
	    EditorCommands.create_state(storage_);
	if (source.equals("Set initial"))
	    EditorCommands.set_initial(storage_);
	if (source.equals("Set final"))
	    EditorCommands.set_final(storage_);
    }



    // Special listener for mouse actions.
    class PopupListener extends MouseAdapter 
    {
        JPopupMenu popup;

        PopupListener(JPopupMenu popupMenu) 
	{
            popup = popupMenu;
        }

        public void mousePressed(MouseEvent e) 
	{
            maybeShowPopup(e);
        }

        public void mouseReleased(MouseEvent e) 
	{
            maybeShowPopup(e);
        }

        private void maybeShowPopup(MouseEvent e) 
	{
            if (e.isPopupTrigger()) 
                popup.show(e.getComponent(), e.getX(), e.getY());
        }
    }


    // Attributes.
    Storage		storage_;

}
