//
// PropertiesTemplate.java for Vcsn in /home/loulou/enst/VcsnInterface
//
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
//
// Started on  Mon Dec 13 14:48:07 2004 Loulou Pouchet
// Last update Sun Jun 19 03:19:26 2005 Louis-Noel Pouchet
//

import vaucanson.vgitoolkit.*;


import javax.swing.JFrame;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public abstract class PropertiesTemplate implements ActionListener
{
    PropertiesTemplate(Storage storage)
    {
	frame_create();
	storage_ = storage;
	is_changed_ = false;
    }


    public void			frame_create()
    {
        // Use nice LookAndFeel.
	JFrame.setDefaultLookAndFeelDecorated(true);

        // Create the frame.
	frame_ = new JFrame();
    }


    public void			frame_show()
    {
	frame_.pack();
	frame_.setVisible(true);
	is_visible = true;
    }


    public void			frame_hide()
    {
	frame_.setVisible(false);
	is_visible = false;
    }


    // Buttons OK and Cancel are always present.
    protected JPanel		create_buttons()
    {
	// Buttons at bottom of the frame.
	bok_ = new JButton("OK");
	bsave_ = new JButton("Save");
	bcancel_ = new JButton("Close");
	bok_.addActionListener(this);
	bsave_.addActionListener(this);
	bcancel_.addActionListener(this);
	JPanel panel_buttons = new JPanel(new GridLayout(1, 2));
	panel_buttons.add(bok_);
	panel_buttons.add(bsave_);
	panel_buttons.add(bcancel_);

	return panel_buttons;
    }


    protected void		frame_panels_set(JPanel normal_panel,
						 JPanel advanced_panel)
    {
        JTabbedPane tabbed_pane = new JTabbedPane();
        tabbed_pane.addTab("Normal", normal_panel);
	tabbed_pane.addTab("Advanced", advanced_panel);

	// Add panels to the frame.
	Container contentPane = frame_.getContentPane();
	contentPane.setLayout(new BorderLayout());
	contentPane.add(tabbed_pane, BorderLayout.CENTER);
 	contentPane.add(create_buttons(), BorderLayout.SOUTH);
    }

    protected void		frame_panel_set(JPanel normal_panel)
    {
	// Add panels to the frame.
	Container contentPane = frame_.getContentPane();
	contentPane.setLayout(new BorderLayout());
	contentPane.add(normal_panel, BorderLayout.CENTER);
 	contentPane.add(create_buttons(), BorderLayout.SOUTH);
    }


    // Attributes.
    protected Storage		storage_;
    protected JFrame		frame_;

    protected JButton		bok_;
    protected JButton		bsave_;
    protected JButton		bcancel_;

    protected boolean		is_changed_;

    public boolean		is_visible = false;
}
