//
// StateProperties.java for Vcsn in /home/loulou/enst/VcsnInterface
//
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
//
// Started on  Mon Dec 13 14:44:06 2004 Loulou Pouchet
// Last update Mon Oct 10 16:54:23 2005 Loulou Pouchet
//

import vaucanson.vgitoolkit.*;

// import javax.swing.*;
// import java.awt.*;
// import java.awt.event.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;
import javax.swing.JMenuBar;
import javax.swing.KeyStroke;
import javax.swing.ImageIcon;

import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFrame;

import javax.swing.filechooser.*;
import java.io.*;
import javax.swing.*;

import java.lang.Integer;

import java.util.Map;
import java.util.Hashtable;
// JGraph
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.CellView;
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.JGraph;


public class StateProperties
    extends PropertiesTemplate
    implements ActionListener, ItemListener
{
    StateProperties(Storage storage)
    {
	super(storage);
	frame_.setTitle("State properties");
	storage_.state_properties_set(this);
	create_frame_elements();
    }


    protected JPanel	create_initial_panel()
    {
	JLabel label1 = new JLabel("Initial multiplicity");

	initial_ = new JCheckBox("Initial state");
	initial_.addItemListener(this);
	initial_label_ = new JTextField("1");

	// Panel for initial state parameters.
	JPanel panel_initial = new JPanel(new GridLayout(1, 2));
	panel_initial.add(initial_label_);
	panel_initial.add(label1);

	JPanel p = new JPanel(new GridLayout(2, 1));
	p.add(initial_);
	p.add(panel_initial);

	return p;
    }


    protected JPanel	create_final_panel()
    {
	JLabel label2 = new JLabel("Final multiplicity");

	final_ = new JCheckBox("Final state");
	final_label_ = new JTextField("1");
	final_.addItemListener(this);

	// Panel for final state parameters.
	JPanel panel_final = new JPanel(new GridLayout(1, 2));
	panel_final.add(final_label_);
	panel_final.add(label2);

	JPanel p = new JPanel(new GridLayout(2, 1));
	p.add(final_);
	p.add(panel_final);

	return p;
    }


    protected JPanel	create_state_panel()
    {
	JLabel label3 = new JLabel("State name");

	// Panel for state properties (name).
	name_ = new JTextField("");
	JPanel panel_state = new JPanel(new GridLayout(3, 2));
	panel_state.add(name_);
	panel_state.add(label3);

	JLabel xlabel = new JLabel("X");
	x_ = new JTextField("");
	panel_state.add(x_);
	panel_state.add(xlabel);

	JLabel ylabel = new JLabel("Y");
	y_ = new JTextField("");
	panel_state.add(y_);
	panel_state.add(ylabel);

	return panel_state;
    }


    protected JPanel	create_advanced_panel()
    {
	JPanel panel = new JPanel(new GridLayout(3, 1));
	JPanel panel0 = new JPanel(new GridLayout(1, 2));
	JPanel panel1 = new JPanel(new BorderLayout());
	JPanel panel2 = new JPanel(new BorderLayout());
	String[] cardinals = {"N", "S", "E", "W", "NE", "NW", "SE", "SW"};

	order_ = new JTextField("");
 	panel0.add(order_);
	panel0.add(new JLabel("Order"));

	initial_angle_ = new JComboBox(cardinals);
	panel1.add(initial_angle_, BorderLayout.WEST);
	panel1.add(new JLabel("Initial transition angle"), BorderLayout.EAST);

	final_angle_ = new JComboBox(cardinals);
	panel2.add(final_angle_, BorderLayout.WEST);
	panel2.add(new JLabel("Final transition angle"), BorderLayout.EAST);

	panel.add(panel0);
	panel.add(panel1);
	panel.add(panel2);

	return panel;
    }


    protected void	create_frame_elements()
    {
	JPanel normal_panel = new JPanel(new BorderLayout());
	normal_panel.add(create_state_panel(), BorderLayout.NORTH);
	normal_panel.add(create_initial_panel(), BorderLayout.CENTER);
	normal_panel.add(create_final_panel(), BorderLayout.SOUTH);

	JPanel advanced_panel = new JPanel(new GridLayout(1, 1));
	advanced_panel.add(create_advanced_panel());
	frame_panels_set(normal_panel, advanced_panel);
    }


    protected void	toggle_initial()
    {
	if (initial_.isSelected())
	    initial_label_.enable();
	else
	    initial_label_.disable();
    }


    protected void	toggle_final()
    {
	if (final_.isSelected())
	    final_label_.enable();
	else
	    final_label_.disable();
    }


    public void		itemStateChanged(ItemEvent e)
    {
	Object source = e.getItemSelectable();

	if (source == initial_)
	    toggle_initial();
	else if (source == final_)
	    toggle_final();
    }


    public void			actionPerformed(ActionEvent e)
    {
 	Object source = e.getSource();

 	if (source == bok_)
	{
	    set_state_properties(state_);
	    frame_hide();
	}
	else if (source == bsave_)
	    set_state_properties(state_);
 	else if (source == bcancel_)
 	    frame_hide();
    }


    public void			frame_show(State s)
    {
	get_state_properties(s);
	state_ = s;
	frame_show();
    }


    public void			get_state_properties(State s)
    {
	int idx = storage_.tabbed_pane_get().getSelectedIndex();

	name_.setText(s.get_label());

	int x = GeometryProperties.getX(s);
	Integer ix = new Integer(x);
	x_.setText(ix.toString());

	int y = GeometryProperties.getY(s);
	Integer iy = new Integer(y);
	y_.setText(iy.toString());

	order_.setText(Integer.toString(s.number_get()));
	if (s.is_initial())
	{
	    initial_.setSelected(true);
	    String label = s.initial_transition_get().get_label();
	    label = (label == null || label == "") ? "1" : label;
	    initial_label_.setText(label);
	}
	else
	{
	    initial_.setSelected(false);
	    initial_label_.disable();
	}
	if (s.is_final())
	{
	    final_.setSelected(true);
	    String label = s.final_transition_get().get_label();
	    label = (label == null || label == "") ? "1" : label;
	    final_label_.setText(label);
	}
	else
	{
	    final_.setSelected(false);
	    final_label_.disable();
	}

	get_if_trans_angle(s);

	/// FIXME: Use attribute map to fill "Advanced" tab.

    }


    public void			set_state_properties(State s)
    {
	s.label_set(name_.getText());
	storage_.set_order(s, order_.getText());

	GeometryProperties.setX(s, (new Integer(x_.getText())).intValue());
	GeometryProperties.setY(s, (new Integer(y_.getText())).intValue());

	if (initial_.isSelected())
	{
	    if (s.is_initial())
		s.update_initial_label(initial_label_.getText());
	    else
		s.set_initial(initial_label_.getText(), null);
	}
	else
	    s.unset_initial();
	if (final_.isSelected())
	{
	    if (s.is_final())
		s.update_final_label(final_label_.getText());
	    else
		s.set_final(final_label_.getText(), null);
	}
	else
	    s.unset_final();

	set_if_trans_angle(s);
	int idx = storage_.tabbed_pane_get().getSelectedIndex();
	Tools.refresh_view(storage_.graph_get(idx));
    }


    public void			get_if_trans_angle(State s)
    {
	double angle;
	if (s.is_initial())
	{
	    initial_angle_.setEnabled(true);
	    angle = GeometryProperties.getTransitionAngle
		(s.initial_transition_get());

	    if (angle == 0)
		initial_angle_.setSelectedItem("E");
	    else if (angle == 45)
		initial_angle_.setSelectedItem("NE");
	    else if (angle == 90)
		initial_angle_.setSelectedItem("N");
	    else if (angle == 135)
		initial_angle_.setSelectedItem("NW");
	    else if (angle == 180)
		initial_angle_.setSelectedItem("W");
	    else if (angle == 225)
		initial_angle_.setSelectedItem("SW");
	    else if (angle == 270)
		initial_angle_.setSelectedItem("S");
	    else if (angle == 315)
		initial_angle_.setSelectedItem("SE");
	}
	else
	    initial_angle_.setEnabled(false);
	if (s.is_final())
	{
	    final_angle_.setEnabled(true);
	    angle = GeometryProperties.getTransitionAngle
		(s.final_transition_get());

	    if (angle == 0)
		final_angle_.setSelectedItem("E");
	    else if (angle == 45)
		final_angle_.setSelectedItem("NE");
	    else if (angle == 90)
		final_angle_.setSelectedItem("N");
	    else if (angle == 135)
		final_angle_.setSelectedItem("NW");
	    else if (angle == 180)
		final_angle_.setSelectedItem("W");
	    else if (angle == 225)
		final_angle_.setSelectedItem("SW");
	    else if (angle == 270)
		final_angle_.setSelectedItem("S");
	    else if (angle == 315)
		final_angle_.setSelectedItem("SE");
	}
	else
	    final_angle_.setEnabled(false);

    }


    public void			set_if_trans_angle(State s)
    {
	String			selected;
	TerminalTransition	t;

	if (s.is_initial())
	{
	    selected = (String) initial_angle_.getSelectedItem();
	    t = s.initial_transition_get();
	    set_trans_angle(selected, t);
	}
	if (s.is_final())
	{
	    selected = (String) final_angle_.getSelectedItem();
	    t = s.final_transition_get();
	    set_trans_angle(selected, t);
	}
    }

    private void		set_trans_angle(String selected,
						TerminalTransition t)
    {
	if (selected == "E")
	    GeometryProperties.setTransitionAngle(t, 0);
	else if (selected == "NE")
	    GeometryProperties.setTransitionAngle(t, 45);
	else if (selected == "N")
	    GeometryProperties.setTransitionAngle(t, 90);
	else if (selected == "NW")
	    GeometryProperties.setTransitionAngle(t, 135);
	else if (selected == "W")
	    GeometryProperties.setTransitionAngle(t, 180);
	else if (selected == "SW")
	    GeometryProperties.setTransitionAngle(t, 225);
	else if (selected == "S")
	    GeometryProperties.setTransitionAngle(t, 270);
	else if (selected == "SE")
	    GeometryProperties.setTransitionAngle(t, 315);
    }

    // Swing components for the frame.
    protected JTextField	name_;
    protected JTextField	x_;
    protected JTextField	y_;
    protected JCheckBox		initial_;
    protected JTextField	initial_label_;
    protected JCheckBox		final_;
    protected JTextField	final_label_;

    // For advanced attributes.
    protected JTextField	order_;
    protected JComboBox		initial_angle_;
    protected JComboBox		final_angle_;

    //
    protected State		state_;
}
