
//Storage.java for Vcsn in /home/loulou/enst/VcsnInterface

//Made by Loulou
//Contact: <loulou@lrde.epita.fr>

//Started on  Sun Nov 28 17:58:04 2004 Loulou
//Last update Thu Oct  6 18:06:19 2005 Loulou Pouchet


import vaucanson.vgitoolkit.*;


import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import javax.swing.JMenu;
import javax.swing.JTextArea;

import java.util.Vector;
import java.lang.Integer;
import java.util.Map;
import java.util.Hashtable;
import java.util.List;
import java.util.ArrayList;



public class Storage
{
	Storage()
	{
	}


	// Methods.
	public void				remove_automaton(int idx)
	{
		graph_.remove(idx);
		filename_.remove(idx);
		label_factory_.remove(idx);
		// 	automaton_structure_.remove(idx);

		graph_count = graph_.size();
	}


	// Accessors.
	public VJGraph			graph_get(int i)
	{
		return (VJGraph) graph_.get(i);
	}


	public int				graph_set(VJGraph g)
	{
		if (graph_ == null)
			graph_ = new ArrayList();
		graph_.add(g);
		graph_count = graph_.size();
		return graph_.size() - 1;
	}

	public int				graph_set(VJGraph g, int i)
	{
		if (graph_ == null)
			graph_ = new ArrayList();
		graph_.set(i, g);
		graph_count = graph_.size();
		return i;
	}


	public void				frame_set(JFrame frame)
	{
		frame_ = frame;
	}


	public JFrame			frame_get()
	{
		return frame_;
	}


	public void				text_set(JTextArea text)
	{
		text_ = text;
	}


	public JTextArea			text_get()
	{
		return text_;
	}


	public int				filename_set(String filename)
	{
		if (filename_ == null)
			filename_ = new ArrayList();
		filename_.add(filename);
		return filename_.size() - 1;
	}

	public int				filename_set(String filename, int i)
	{
		if (filename_ == null)
			filename_ = new ArrayList();
		filename_.set(i, filename);
		return i;
	}

	public String			filename_get(int i)
	{
		return (String) filename_.get(i);
	}


	public int				filename_get_idx(String str)
	{
		return filename_.indexOf(str);
	}


	public int				name_set(String name)
	{
		if (name_ == null)
			name_ = new ArrayList();
		name_.add(name);
		return name_.size() - 1;
	}

	public int				name_set(String name, int i)
	{
		if (name_ == null)
			name_ = new ArrayList();
		name_.set(i, name);
		return i;
	}

	public String			name_get(int i)
	{
		return (String) name_.get(i);
	}


	public int				name_get_idx(String str)
	{
		return name_.indexOf(str);
	}


	public void				executable_set(String executable)
	{
		executable_ = executable;
	}


	public String			executable_get()
	{
		return executable_;
	}


	public void				state_properties_set
	(StateProperties sp)
	{
		state_properties_ = sp;
	}


	public StateProperties		state_properties_get()
	{
		return state_properties_;
	}


	public void				transition_properties_set
	(TransitionProperties tp)
	{
		transition_properties_ = tp;
	}


	public TransitionProperties		transition_properties_get()
	{
		return transition_properties_;
	}


	public LabelFactory			name_factory_get()
	{
		if (name_factory_ == null)
			name_factory_ = new LabelFactory("Automaton");
		return name_factory_;
	}


	public LabelFactory			label_factory_get(int i)
	{
		return (LabelFactory) label_factory_.get(i);
	}


	public int				label_factory_set(LabelFactory lf)
	{
		if (label_factory_ == null)
			label_factory_ = new ArrayList();
		label_factory_.add(lf);
		return label_factory_.size() - 1;
	}

	public int				label_factory_set(LabelFactory lf,
			int i)
	{
		if (label_factory_ == null)
			label_factory_ = new ArrayList();
		label_factory_.set(i, lf);
		return i;
	}


	public void				automaton_structure_properties_set
	(AutomatonStructureProperties tp)
	{
		automaton_structure_properties_ = tp;
	}


	public AutomatonStructureProperties
	automaton_structure_properties_get()
	{
		return automaton_structure_properties_;
	}


	//     public Map				automaton_structure_get(int i)
	//     {
	// 	return (Map) automaton_structure_.get(i);
	//     }


	//     public int				automaton_structure_set(Hashtable ht)
	//     {
	// 	if (automaton_structure_ == null)
	// 	    automaton_structure_ = new ArrayList();
	// 	automaton_structure_.add(ht);
	// 	return automaton_structure_.size() - 1;
	//     }


	//     public int				automaton_structure_set(Hashtable ht,
	// 								int i)
	//     {
	// 	if (automaton_structure_ == null)
	// 	    automaton_structure_ = new ArrayList();
	// 	automaton_structure_.set(i, ht);
	// 	return i;
	//     }

	public void				executable_set(String type,
			String weight)
	{
		Debug.echo(System.getProperty("user.dir"));
		if (type.equals("FMP transducer"))
			executable_ = "bin/vcsn-tdc";
		else if (type.equals("Realtime transducer"))
			executable_ = "bin/VGI_rt_tdc";
		else
			executable_ = "bin/vcsn-" + weight.toLowerCase();
	}


	public void				mode_set(int mode)
	{
		mode_ = mode;
	}

	public int				mode_get()
	{
		return mode_;
	}


	public CreateStateFrame		create_state_frame_get()
	{
		return create_state_frame_;
	}


	public void				create_state_frame_set
	(CreateStateFrame frame)
	{
		create_state_frame_ = frame;
	}

	//     public void				tabbed_pane_set(JTabbedPane tp)
	//     {
	// 	tabbed_pane_ = tp;
	//     }

	public JTabbedPane			tabbed_pane_get()
	{
		if (tabbed_pane_ == null)
		{
			TabbedPaneChangeListener tcl =
				new TabbedPaneChangeListener(this);
			tabbed_pane_ = new JTabbedPane();
			tabbed_pane_.addChangeListener(tcl);
		}
		return tabbed_pane_;
	}

	public String			get_order(State key)
	{
		if (state_order_ == null)
			state_order_ = new Hashtable();
		return (String) state_order_.get(key);
	}

	public void				set_order(State key, String value)
	{
		if (state_order_ == null)
			state_order_ = new Hashtable();
		state_order_.put(key, value);
	}

	public void				alphabet_set(String s)
	{
		if (s == null)
			return;

		char[] out = s.toCharArray();
		char[] alp = new char[256];
		String res = new String("");
		for (int i = 0; i < 256; ++i)
			alp[i] = 0;
		for (int i = 0; i < s.length(); ++i)
		{
			if (out[i] != '(' && out[i] != ')' && out[i] != '+' &&
					out[i] != '*' && out[i] != '.')
				alp[out[i]]++;
		}
		for (char i = 0; i < 256; ++i)
			if (alp[i] != 0)
				res += i;
		alphabet_ = res;
	}

	public String			alphabet_get()
	{
		return "--alphabet=" + alphabet_;
	}

	// Attributes.
	protected List			graph_ = null;
	protected JFrame			frame_ = null;
	protected JTextArea			text_ = null;
	protected List			filename_ = null;
	protected List			name_ = null;
	protected String			executable_ = "b";
	protected String			alphabet_ = null;
	protected StateProperties		state_properties_ = null;
	protected TransitionProperties	transition_properties_ = null;
	protected List			label_factory_ = null;
	protected AutomatonStructureProperties
	automaton_structure_properties_ = null;

	protected LabelFactory		name_factory_ = null;
	protected CreateStateFrame		create_state_frame_ = null;

	//     protected List			automaton_structure_;
	protected int			mode_;
	protected JTabbedPane		tabbed_pane_ = null;
	protected Hashtable			state_order_ = null;


	public int				graph_count = 0;
	public int				document_count = 0;
}
