//
// TabbedPaneChangeListener.java for VGI in /home/loulou/enst/vgi-dev
// 
// Made by Louis-Noel Pouchet
// Login   <loulou@lrde.epita.fr>
// 
// Started on  Sun Jan 23 20:05:00 2005 Louis-Noel Pouchet
// Last update Sun Jan 23 22:21:41 2005 Louis-Noel Pouchet
//


import vaucanson.vgitoolkit.*;
import javax.swing.event.*;


// Change listener for the main tabbed pane.
public class TabbedPaneChangeListener implements ChangeListener
{
    TabbedPaneChangeListener(Storage storage)
    {
	storage_ = storage;
    }

    // Set the propertie windows to the correct value when changing tab.
    public void stateChanged(ChangeEvent e)
    {
 	int idx = storage_.tabbed_pane_get().getSelectedIndex();
 	if (idx == -1)
	    return;
	VJGraph graph = storage_.graph_get(idx);
	Object[] cells = graph.getSelectionCells();

	// Update properties windows.
	Object cell;
	for (int i = 0; i < cells.length; ++i)
	    {
		cell = cells[i];
		if (cell != null)
		    if (((cell instanceof State ||
			  cell instanceof TerminalTransition) &&
			 storage_.state_properties_get().is_visible) 
			|| (cell instanceof Transition &&
			    storage_.transition_properties_get()
			    .is_visible))
			EditorCommands.properties(storage_);
	    }
    }

    // Attributes.
    protected Storage	storage_;

}
