
//VGI.java for VGI in /home/loulou/lrde_proj/vgi/src/vgi

//Made by Louis-Noel Pouchet
//Login   <loulou@lrde.epita.fr>

//Started on  Sat Jun 18 22:59:17 2005 Louis-Noel Pouchet
//Last update Sat Jun 18 23:12:31 2005 Louis-Noel Pouchet



import vaucanson.vgitoolkit.*;


import org.jgraph.JGraph;
import org.jgraph.graph.*;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.BorderFactory;
import javax.swing.JTextArea;

import java.util.Map;
import java.util.Hashtable;

import java.awt.Rectangle;
import java.awt.Color;


///
import javax.swing.*;
import java.awt.*;

//Exceptions
//SAX
import org.xml.sax.SAXException;
//Java
import java.io.IOException;


public class VGI
{
	private static void	create_show_GUI(Storage storage)
	{
		// Use nice LookAndFeel.
		JFrame.setDefaultLookAndFeelDecorated(true);

		// Create the frame.
		JFrame frame = new JFrame("Vaucanson");
		storage.frame_set(frame);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(640, 480);

		// Get contentPane for the frame.
		Container content_pane = frame.getContentPane();
		content_pane.setLayout(new BorderLayout());

		// Create menu.
		MenuBar menu = new MenuBar(storage);
		frame.setJMenuBar(menu.create_menu_bar());

		// Create toolbar.
		EditorToolbar tb = new EditorToolbar(storage);
		content_pane.add(tb.create_toolbar(), BorderLayout.NORTH);

		//storage.frame_get().getContentPane().add(storage.tabbed_pane_get(),
		//				 BorderLayout.CENTER);

		// Text zone: display values returned by algorithm.
		storage.text_set(new JTextArea(5, 0));

		JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
				storage.tabbed_pane_get(),
				new JScrollPane(storage.text_get()));

		content_pane.add(split, BorderLayout.CENTER);

		// Handle properties windows.
		PropertiesTemplate prop;
		prop = new StateProperties(storage);
		prop = new TransitionProperties(storage);
		prop = new AutomatonStructureProperties(storage);

		CreateStateFrame f = new CreateStateFrame(storage);

		//Display the window.
		//frame.pack();
		frame.setVisible(true);

		// Top component use 80 of space, even after a resize.
		split.setDividerLocation(0.80);
		split.setResizeWeight(1.0);
	}



	public static void		main(String[] args)
	throws IOException, SAXException
	{
		final Storage storage = new Storage();
		storage.executable_set("bin/" + VJToolKitConstants.VCSN_PROG_NAME);
		if (args.length > 0)
			for (int i = 0; i < args.length; ++i)
				EditorCommands.create_graph(args[i], storage);
		else
			EditorCommands.create_empty_graph(storage);

		javax.swing.SwingUtilities.invokeLater(new Runnable()
		{
			public void run()
			{
				create_show_GUI(storage);
			}
		});
	}
}
