//
// CenterGraphLayout.java for Vcsn in /home/loulou/enst/VcsnInterface
//
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
//
// Started on  Wed Dec 29 16:36:46 2004 Loulou Pouchet
// Last update Tue Dec  5 20:28:31 2006 Guillaume
//

package vaucanson.vgitoolkit;


import org.jgraph.JGraph;
import org.jgraph.graph.CellView;
import org.jgraph.graph.VertexView;

import java.awt.geom.Rectangle2D;
import java.awt.Rectangle;
import java.awt.geom.Point2D;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Map;
import java.util.Set;
import java.util.ArrayList;
import java.util.List;


public class CenterGraphLayout
  extends LayoutTemplate
{
    public void		apply(VJGraph source_graph, Object[] cells)
    {
	List vertices;

	// Get available vertices.
	vertices = get_all_vertices(initialize_layout(source_graph));

	// Run the layout algorithm.
	run_layout(vertices);

	// Finalize the algorithm by updating current graph with new values.
	finalize_layout(vertices);
	Tools.refresh_view(source_graph);
    }



    public void		run_layout(List vertices)
    {

	double maxx = -20000, maxy = -20000;
	double minx = 20000, miny = 20000;


	for (int i = 0; i < vertices.size(); ++i)
	{
	    State s = (State) vertices.get(i);
	    double x = (double) GeometryProperties.getX(s);
	    double y = (double) GeometryProperties.getY(s);

	    maxx = Math.max(maxx, x);
	    maxy = Math.max(maxy, y);

	    minx = Math.min(minx, x);
	    miny = Math.min(miny, y);
	}

	Point2D mid = new Point2D.Double(minx + Math.abs(maxx - minx) / 2,
					 miny + Math.abs(maxy - miny) / 2);
	Point2D smid = source_graph_.toScreen
	    (GeometricUtilities.toScreen(source_graph_, mid));
	Rectangle2D bounds = source_graph_.getParent().getBounds();
	Rectangle viewport = new Rectangle
	    ((int)Math.round(smid.getX() - bounds.getWidth() / 2),
	     (int)Math.round(smid.getY() - bounds.getHeight() / 2),
	     (int)Math.round(bounds.getWidth()),
	     (int)Math.round(bounds.getHeight()));
	source_graph_.scrollRectToVisible(viewport);
    }

}
