//
// CircleGraphLayout.java for Vcsn in /home/loulou/enst/VcsnInterface
//
// Made by Loulou Pouchet
// Login   <loulou@lrde.epita.fr>
//
// Started on  Tue Dec 28 17:16:52 2004 Loulou Pouchet
// Last update Fri Dec  8 02:05:19 2006 Guillaume
//

package vaucanson.vgitoolkit;



import org.jgraph.graph.CellView;
import java.awt.geom.Point2D;
import java.util.List;


public class CircleGraphLayout extends LayoutTemplate
{
    public static int		compute_radius(VJGraph graph,
					       Object[] cells,
					       boolean force)
    {
	List vertices;
	int max = 0;

	vertices = get_vertices(graph, cells, force);

	return (int) Math.max(vertices.size() / 2, 5);
    }


    public void			apply(VJGraph source_graph,
				      Object[] cells)
    {
	apply(source_graph,
	      cells,
	      compute_radius(source_graph, cells, true),
	      true);
    }


    public void			apply(VJGraph source_graph,
				      Object[] cells,
				      int radius)
    {
	apply(source_graph, cells, radius, true);
    }


    public void			apply(VJGraph source_graph,
				      Object[] cells,
				      int radius,
				      boolean force)
    {
	List vertices;

	vertices = get_vertices(initialize_layout(source_graph), cells, force);

	// Run the layout algorithm.
	run_layout(vertices, radius);
	// Finalize the algorithm by updating current graph with new values.
	finalize_layout(vertices);

	Tools.refresh_view(source_graph);
    }




    public static void		run_layout(List vertices, int radius)
    {
	if (radius < 1)
	    return;

	double step = 2 * Math.PI / vertices.size();
	for (int i = 0; i < vertices.size(); ++i)
	{
	    GeometryProperties.setX((State)vertices.get(i),
				    (int)(radius * Math.sin(i * step)));
	    GeometryProperties.setY((State)vertices.get(i),
				    (int)(radius * Math.cos(i * step)));
	}
    }

}
