//
// DrawingProperties.java for vgi in /home/loulou/lrde_proj/vgi/src/vgitoolkit
//
// Made by Guillaume Leroi
// Login   <guillaume.leroi@lrde.epita.fr>
//
//

package vaucanson.vgitoolkit;
import java.util.Map;

public class DrawingProperties
{
    // XSD constants.
    public final static String STATESIZE = "stateSize";
    public final static String STATECOLOR = "stateColor";
    public final static String STATEFILLCOLOR = "stateFillColor";



    public final static String LABELPOSITIONX = "labelPositionX";
    public final static int LABELPOSITIONXDEFAULT = 0;

    // X absolute position of label
    public final static int getLabelPositionX(TransitionTemplate t)
    {
	Map drawing = t.drawing_get();
	String str = (String) drawing.get(LABELPOSITIONX);

	if (str != null)
	{
	    Integer ipos = new Integer(str);
	    return ipos.intValue();
	}
	else
	    return LABELPOSITIONXDEFAULT;
    }

    public final static void setLabelPositionX(TransitionTemplate t, int x)
    {
	Map drawing = t.drawing_get();
	Integer ix = new Integer(x);
	drawing.put(LABELPOSITIONX, ix.toString());
    }



    // Y absolute position of label
    public final static String LABELPOSITIONY = "labelPositionY";
    public final static int LABELPOSITIONYDEFAULT = 0;

    public final static int getLabelPositionY(TransitionTemplate t)
    {
	Map drawing = t.drawing_get();
	String str = (String) drawing.get(LABELPOSITIONY);

	if (str != null)
	{
	    Integer ipos = new Integer(str);
	    return ipos.intValue();
	}
	else
	    return LABELPOSITIONYDEFAULT;
    }

    public final static void setLabelPositionY(TransitionTemplate t, int x)
    {
	Map drawing = t.drawing_get();
	Integer ix = new Integer(x);
	drawing.put(LABELPOSITIONY, ix.toString());
    }



    // Give the distance from the transition of the label
    public final static String LABELOFFSET = "labelOffset";
    public final static int LABELOFFSETDEFAULT = 5;

    public final static int getLabelOffset(TransitionTemplate t)
    {
	Map drawing = t.drawing_get();
	String str = (String) drawing.get(LABELOFFSET);

	if (str != null)
	{
	    Integer ioff = new Integer(str);
	    return ioff.intValue();
	}
	else
	    return LABELOFFSETDEFAULT;
    }

    public final static void setLabelOffset(TransitionTemplate t, int offset)
    {
	Map drawing = t.drawing_get();
	Integer ioff = new Integer(offset);

	drawing.put(LABELOFFSET, ioff.toString());
    }


    public final static String STATELABELCOLOR = "StateLabelColor";
    public final static String STATELABELSCALE = "StateLabelScale";
    public final static String STATELINESTYLE = "StateLineStyle";
    public final static String STATELINEWIDTH = "StateLineWidth";
    public final static String STATELINECOLOR = "StateLineColor";
    public final static String STATEFILLSTATUS = "StateFillStatus";
    public final static String DIMSTATELINESTYLE = "DimStateLineStyle";
    public final static String DIMSTATELINECOLOR = "DimStateLineColor";
    public final static String DIMSTATELINECOEF = "DimStateLineCoef";
    public final static String DIMSTATELABELCOLOR = "DimStateLabelColor";
    public final static String DIMSTATEFILLCOLOR = "DimStateFillColor";
    public final static String STATELINEDBLCOEF = "StateLineDblCoef";
    public final static String STATELINEDBLSEP = "StateLineDblSep";
    public final static String TRANSITIONLABELCOLOR = "TransitionLabelColor";
    public final static String TRANSITIONLABELSCALE = "TransitionLabelScale";
    public final static String TRANSITIONLINESTYLE = "TransitionLineStyle";
    public final static String TRANSITIONLINEWIDTH = "TransitionLineWidth";
    public final static String TRANSITIONLINECOLOR = "TransitionLineColor";
    public final static String ARCANGLE = "ArcAngle";
    public final static String LARCANGLE = "LArcAngle";
    public final static String ARCCURVATURE = "ArcCurvature";
    public final static String TRANSITIONOFFSET = "TransitionOffset";
    public final static String ARCOFFSET = "ArcOffset";
    public final static String LOOPOFFSET = "LoopOffset";
    public final static String FORTHBACKTRANSITIONOFFSET = "ForthBackTransitionOffset";
    public final static String DIMTRANSITIONLINESTYLE = "DimTransitionLineStyle";
    public final static String DIMTRANSITIONLINECOEF = "DimTransitionLineCoef";
    public final static String DIMTRANSITIONLINECOLOR = "DimTransitionLineColor";
    public final static String DIMTRANSITIONLABELCOLOR = "DimTransitionLabelColor";
    public final static String TRANSITIONBORDERCOEF = "TransitionBorderCoef";
    public final static String TRANSITIONBORDERCOLOR = "TransitionBorderColor";
    public final static String TRANSITIONLINEDOUBLECOEFONE = "TransitionLineDoubleCoefOne";
    public final static String TRANSITIONLINEDOUBLECOEFTWO = "TransitionLineDoubleCoefTwo";
    public final static String ZZSIZE = "ZZSize";
    public final static String ZZSHAPE = "ZZShape";
    public final static String ZZLINEWIDTH = "ZZLineWidth";
    public final static String TRANSLABELZZCOEF = "TransLabelZZCoef";
    public final static String LARGESCALE = "LargeScale";
    public final static String MEDIUMSCALE = "MediumScale";
    public final static String SMALLSCALE = "SmallScale";
    public final static String TINYSCALE = "TinyScale";
    public final static String MEDIUMSTATEDIAMETER = "MediumStateDiameter";
    public final static String SMALLSTATEDIAMETER = "SmallStateDiameter";
    public final static String LARGESTATEDIAMETER = "LargeStateDiameter";
    public final static String VERYSMALLSTATEDIAMETER = "VerySmallStateDiameter";
    public final static String VSSTATELINECOEF = "VSStateLineCoef";
    public final static String ARROWONMEDIUMSTATE = "ArrowOnMediumState";
    public final static String ARROWONSMALLSTATE = "ArrowOnSmallState";
    public final static String ARROWONLARGESTATE = "ArrowOnLargeState";
    public final static String ARROWONVERYSMALLSTATE = "ArrowOnVerySmallState";
    public final static String LOOPONMEDIUMSTATE = "LoopOnMediumState";
    public final static String LOOPONSMALLSTATE = "LoopOnSmallState";
    public final static String LOOPONLARGESTATE = "LoopOnLargeState";
    public final static String LOOPONVARIABLESTATE = "LoopOnVariableState";
    public final static String CLOOPONMEDIUMSTATE = "CLoopOnMediumState";
    public final static String CLOOPONSMALLSTATE = "CLoopOnSmallState";
    public final static String CLOOPONLARGESTATE = "CLoopOnLargeState";
    public final static String CLOOPONVARIABLESTATE = "CLoopOnVariableState";
    public final static String TRANSITIONLABELPOSIT = "TransitionLabelPosit";
    public final static String TRANSITIONLABELREVPOSIT = "TransitionLabelRevPosit";
    public final static String ARCLABELPOSIT = "ArcLabelPosit";
    public final static String ARCLABELREVPOSIT = "ArcLabelRevPosit";
    public final static String LARCLABELPOSIT = "LArcLabelPosit";
    public final static String LARCLABELREVPOSIT = "LArcLabelRevPosit";
    public final static String LOOPLABELPOSIT = "LoopLabelPosit";
    public final static String LOOPLABELREVPOSIT = "LoopLabelRevPosit";
    public final static String CLOOPLABELPOSIT = "CLoopLabelPosit";
    public final static String CLOOPLABELREVPOSIT = "CLoopLabelRevPosit";
    public final static String INITSTATELABELPOSIT = "InitStateLabelPosit";
    public final static String INITSTATELABELREVPOSIT = "InitStateLabelRevPosit";
    public final static String FINALSTATELABELPOSIT = "FinalStateLabelPosit";
    public final static String FINALSTATELABELREVPOSIT = "FinalStateLabelRevPosit";
    public final static String TRANSITIONARROWWIDTH = "TransitionArrowWidth";
    public final static String TRANSITIONARROWLENGTHCOEF = "TransitionArrowLengthCoef";
    public final static String TRANSITIONDBLARROWWIDTH = "TransitionDblArrowWidth";
    public final static String TRANSITIONDBLARROWLENGTHCOEF = "TransitionDblArrowLengthCoef";
    public final static String TRANSITIONARROWINSETCOEF = "TransitionArrowInsetCoef";
    public final static String TRANSITIONARROWSTYLE = "TransitionArrowStyle";
    public final static String TRANSITIONREVARROWSTYLE = "TransitionRevArrowStyle";
    public final static String STATEDIMEN = "StateDimen";
    public final static String STATEDBLDIMEN = "StateDblDimen";
    public final static String LEFT = "left";
    public final static String BOTTOM = "bottom";
    public final static String TOP = "top";
    public final static String RIGHT = "right";
    public final static String LABEL = "label";
    public final static String X = "x";
    public final static String Y = "y";
    public final static String CURVATURE = "curvature";
    public final static String CURVSIDE = "curvside";
    public final static String DIRECTION = "direction";
    public final static String DOUBLELINE = "doubleline";


}
