
//TerminalTransitionRouter.java for vgi in /home/loulou/lrde_proj/vgi/src

//Made by Louis-Noel Pouchet
//Login   <loulou@lrde.epita.fr>

//Started on  Wed Mar  2 17:26:04 2005 Louis-Noel Pouchet
//Last update Mon Jun 20 20:13:10 2005 Louis-Noel Pouchet



package vaucanson.vgitoolkit;


import org.jgraph.graph.Edge;
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.CellView;
import org.jgraph.graph.EdgeView;
import org.jgraph.graph.PortView;
import java.awt.geom.Point2D;
import java.lang.Double;
import java.util.List;
import org.jgraph.util.Bezier;

import java.awt.geom.Rectangle2D;


import org.jgraph.graph.EdgeRenderer;
//Router for initial and final transitions.
public class TerminalTransitionRouter implements Edge.Routing
{
	public static TerminalTransitionRouter sharedInstance =
		new TerminalTransitionRouter();


	/**
	 * @param edge and edge View
	 *
	 * @return the preferred line style (here BEZIER)
	 */
	public int getPreferredLineStyle(EdgeView edge)
	{
		return GraphConstants.STYLE_SPLINE;
	}


	public List route(EdgeView edge)
	{
		List points = edge.getPoints();
		if (edge.getTarget() == null)
			return points;
		Point2D from = ((PortView) edge.getTarget()).getLocation();
		Rectangle2D bounds = ((PortView) edge.getTarget()).getBounds();

		double alpha = 0;
		TerminalTransition trans = (TerminalTransition) edge.getCell();

		// Only try to get a fresh angle if it is the first computation,
		// or if it is forced.
		if (GeometryProperties.getTransitionAngle(trans) == -1)
		{
			Debug.echo("route for terminal transitions:" + trans.state_get().toString());
			int ialpha = GeometricUtilities.get_free_angle
			(trans.state_get().graph_get(), trans.state_get(), trans);
			GeometryProperties.setTransitionAngle(trans, ialpha);
			alpha = ((double)ialpha) * Math.PI / 180;
		}
		else
			alpha = ((double)GeometryProperties.getTransitionAngle(trans)) *
			Math.PI / 180;

		Point2D to = new Point2D.Double();
		Debug.echo(alpha * 180 / Math.PI);
		to.setLocation(from.getX() + Math.cos(alpha) *
				VJToolKitConstants.ARROW_LENGTH,
				from.getY() - Math.sin(alpha) *
				VJToolKitConstants.ARROW_LENGTH);

		if (points.size() == 2)
			points.set(0, to);
		else
			points.add(0, to);
		return points;
	}
}
