
//Transition.java for vgi in /home/loulou/lrde_proj/vgi/src

//Made by Louis-Noel Pouchet
//Login   <loulou@lrde.epita.fr>

//Started on  Wed Mar  2 15:42:20 2005 Louis-Noel Pouchet
//Last update Wed Jun 22 23:30:59 2005 Louis-Noel Pouchet



package vaucanson.vgitoolkit;


import org.jgraph.JGraph;
import org.jgraph.graph.*;
import java.util.Map;
import java.util.Hashtable;

import java.awt.geom.Point2D;


public class Transition extends TransitionTemplate
{
	public Transition(State src, State dst, Map geom,
			GraphModel model, VJGraph graph)
	{
		super();
		// FIXME: Use name factory here.
		create_transition("", src, dst, null, null, geom, model, graph);
	}


	public Transition(String name,
			State src,
			State dst,
			String label,
			Map geom,
			GraphModel model,
			VJGraph graph)
	{
		super();
		create_transition(name, src, dst, label, null, geom, model, graph);
	}


	public Transition(String name,
			State src,
			State dst,
			String label,
			String weight,
			Map geom,
			GraphModel model,
			VJGraph graph)
	{
		super();
		create_transition(name, src, dst, label, weight, geom, model, graph);
	}


	protected void		create_transition(String name,
			State src,
			State dst,
			String label,
			String weight,
			Map geom,
			GraphModel model,
			VJGraph graph)
	{
		graph_ = graph;
		name_ = name;
		graph_model_ = model;
		label_set(label);
		weight_set(weight);
		connect(src, dst);
		VJTools.init_jgraph_attributes(this);
		VJTools.set_geometry(this);
		
		geometry_set(geom);
	}


	public void			connect(State src, State dst)
	{
		if (this.src_ != src || this.dst_ != dst)
		{
			ConnectionSet cs = new ConnectionSet();
			cs.connect(this, src.port_get(), dst.port_get());
			Map change = new Hashtable();
			Map map = graph_model_.getAttributes(this);
			change.put(this, map);
			graph_model_.edit(change, cs, null, null);
			src_ = src;
			dst_ = dst;
		}
	}


	public void			src_set(State src)
	{
		src_ = src;
	}


	public State		src_get()
	{
		return src_;
	}


	public void			dst_set(State dst)
	{
		dst_ = dst;
	}


	public State		dst_get()
	{
		return dst_;
	}


	public int			loop_size_get()
	{
		return loop_size_;
	}


	public void			loop_size_set(int val)
	{
		loop_size_ = val;
	}

	public VJGraph		graph_get()
	{
		return graph_;
	}

	// Attributes.
	protected VJGraph		graph_;
	protected String		name_;
	protected State		src_ = null;
	protected State		dst_ = null;
	protected int		loop_size_ = 0;
}
