
//TransitionTemplate.java for vgi in /home/loulou/lrde_proj/vgi/src

//Made by Louis-Noel Pouchet
//Login   <loulou@lrde.epita.fr>

//Started on  Wed Mar  2 14:48:01 2005 Louis-Noel Pouchet
//Last update Wed Jun 22 02:29:30 2005 Louis-Noel Pouchet



package vaucanson.vgitoolkit;


import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.GraphModel;
import org.jgraph.graph.GraphConstants;
import java.util.Map;
import java.util.Hashtable;

import java.awt.Point;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;


public class TransitionTemplate extends DefaultEdge
{
	public TransitionTemplate()
	{
		super();
	}


	public TransitionTemplate(Object obj)
	{
		super(obj);
	}

	public String		get_label()
	{
		return super.toString();
	}

	public String		label_get()
	{
		return label_;
	}


	public void			label_set(String label)
	{
		if (label != null && label.equals("1"))
			label_ = "";
		else
			label_ = label;
		update_label();
	}


	// FIXME: This is used for tranducers, but should be changed.
	public void			weight_set(String weight)
	{
		weight_ = weight;
		update_label();
	}

	public String		weight_get()
	{
		return weight_;
	}


	public void			update_label()
	{
		if (graph_model_ != null && label_ != null)
		{
			String label = label_;
			if (weight_ != null && ! weight_.equals(""))
				label += " | " + weight_;
			Map attrib = graph_model_.getAttributes(this);
			GraphConstants.setValue(attrib, label);
			Map map = new Hashtable();
			map.put(this, attrib);
			graph_model_.edit(map, null, null, null);
		}
	}


	public Map			get_attributes_map()
	{
		return graph_model_.getAttributes(this);
	}


	public void			graph_model_set(GraphModel graph_model)
	{
		graph_model_ = graph_model;
	}


	public GraphModel		graph_model_get()
	{
		return graph_model_;
	}

	public Map			geometry_get()
	{
		if (geometry_map_ == null)
			geometry_map_ = new Hashtable();
		return geometry_map_;
	}

	public void			geometry_set(Map map)
	{
		geometry_map_ = map;
	}

	public Map			drawing_get()
	{
		if (drawing_map_ == null)
			drawing_map_ = new Hashtable();
		return drawing_map_;
	}

	public void			drawing_set(Map map)
	{
		drawing_map_ = map;
	}


	// Attributes.
	protected GraphModel	graph_model_;
	protected String		label_;
	protected String		weight_ = null;
	protected Map		geometry_map_ = null;
	protected Map		drawing_map_ = null;
	protected double		angle_ = 0;

	// Used for both terminal transitions and loops.
	public boolean label_is_set = false;
}
