
//VJTools.java for vgi in /home/loulou/lrde_proj/vgi/src

//Made by Louis-Noel Pouchet
//Login   <loulou@lrde.epita.fr>

//Started on  Wed Mar  2 15:50:59 2005 Louis-Noel Pouchet
//Last update Thu Jan  4 17:31:36 2007 Guillaume


package vaucanson.vgitoolkit;


import org.jgraph.util.*;

import org.jgraph.JGraph;
import org.jgraph.graph.*;
import org.jgraph.*;
import org.jgraph.util.*;

import java.util.Map;
import java.util.Hashtable;

import java.awt.Color;


public class VJTools
{

	public static void init_jgraph_attributes(VJGraph graph)
	{
		graph.setInvokesStopCellEditing(true);
		graph.setJumpToDefaultPort(true);

		//Tell the Graph to Select new Cells upon Insertion
		// 		graph.setSelectNewCells(true);
		//Make Ports Visible by Default
		graph.setPortsVisible(true);
		//Use the Grid
		graph.setGridEnabled(true);
		graph.setGridVisible(true);
		graph.setGridSize(VJToolKitConstants.PIXEL_PER_CM);
		graph.setTolerance(2);

		graph.setMoveBelowZero(true);
		graph.setAutoResizeGraph(false);
		graph.setAntiAliased(true);
		graph.setAntiAliased(true);
	}

	public static void init_jgraph_attributes(State s)
	{
		Map attr_map = new Hashtable();
		Map global_map = new Hashtable();

		GraphConstants.setAutoSize(attr_map, true);
		GraphConstants.setAbsolute(attr_map, false);
		if (s.label_get() != null)
			GraphConstants.setValue(attr_map, s.label_get());
		GraphConstants.setBorderColor(attr_map, Color.black);

		global_map.put(s, attr_map);
		s.graph_model_get().insert(new Object[]{s}, global_map,
				null, null, null);
		//  	s.graph_get().getGraphLayoutCache().removeMapping(s);
		s.graph_get().getGraphLayoutCache().putMapping(s, new StateView(s));
	}


	public static void init_jgraph_attributes(Transition t)
	{
		ConnectionSet cs = new ConnectionSet();
		Map attr_map = new Hashtable();
		Map global_map = new Hashtable();

		GraphConstants.setLineEnd(attr_map, GraphConstants.ARROW_CLASSIC);
		GraphConstants.setEndFill(attr_map, true);
		GraphConstants.setLineStyle(attr_map, GraphConstants.STYLE_SPLINE);
		GraphConstants.setDisconnectable(attr_map, false);
		GraphConstants.setBendable(attr_map, true);
		GraphConstants.setBorderColor(attr_map, Color.BLACK);
		// Use another router to print curvated edges.
		if (t.src_get() == t.dst_get())
			GraphConstants.setRouting(attr_map, new LoopRouter());
		else
			GraphConstants.setRouting(attr_map, new TransitionRouter());

		global_map.put(t, attr_map);
		t.graph_model_get().insert(new Object[]{t}, global_map, cs,
				null, null);
		t.graph_get().getGraphLayoutCache().putMapping(t, new TransitionView(t));
	}


	// Should only be called at the end of TerminalTransition constructor.
	public static void init_jgraph_attributes(TerminalTransition t)
	{
		Map attr_map = new Hashtable();
		Map global_map = new Hashtable();
		ConnectionSet cs = new ConnectionSet();

		if (t.type_get() == VJToolKitConstants.INITIAL_TRANSITION)
			GraphConstants.setLineEnd(attr_map, GraphConstants.ARROW_CLASSIC);
		else
			GraphConstants.setLineBegin(attr_map,
					GraphConstants.ARROW_CLASSIC);
		GraphConstants.setEndFill(attr_map, true);
		GraphConstants.setBeginFill(attr_map, true);
		cs.connect(t, t.state_get().port_get(), false);
		GraphConstants.setAbsolute(attr_map, false);
		GraphConstants.setRouting
		(attr_map, new TerminalTransitionRouter());
		GraphConstants.setDisconnectable(attr_map, false);

		global_map.put(t, attr_map);
		t.graph_model_get().insert(new Object[]{t}, global_map, cs,
				null, null);
	}



	public static void set_geometry(State s)
	{

	}


	public static void set_geometry(Transition t)
	{

	}


	public static void set_geometry(TerminalTransition t)
	{

	}


	public static void set_state_mapping(VJGraph graph)
	{
		Object[] set = DefaultGraphModel.getAll(graph.getModel());

		for (int i = 0; i < set.length; ++i)
			if (set[i] instanceof State)
			{
				graph.getGraphLayoutCache().removeMapping(set[i]);
				graph.getGraphLayoutCache().putMapping(set[i],
						new StateView(set[i]));
			}
	}
}
