
//XMLReader.java for vgi in /home/loulou/lrde_proj/vgi/src/vgitoolkit

//Made by Louis-Noel Pouchet
//Login   <loulou@lrde.epita.fr>

//Started on  Thu Mar  3 23:49:36 2005 Louis-Noel Pouchet
// Last update Wed Nov 21 15:15:26 2007 Louis-Noel Pouchet



package vaucanson.vgitoolkit;


//Apache - Xerces Parser
import org.apache.xerces.parsers.DOMParser;
//DOM
import org.w3c.dom.*;

import org.xml.sax.SAXException;
import java.io.IOException;

//Input / Output
import org.xml.sax.InputSource;

import java.io.FileDescriptor;
import java.io.FileReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.io.FileNotFoundException;

import java.util.Map;
import java.util.Hashtable;

//Layout
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.util.*;
import org.jgraph.layout.*;

import sun.beans.editors.StringEditor;

import com.sun.imageio.plugins.common.InputStreamAdapter;



public class XMLReader
{

	// Shortcut.
	public static VJGraph		file_to_graph(String s)
	{
		VJGraph g = XMLConverter.xml_to_graph(parse_from_filename(s));
		//   	apply_layout(g);
		return g;
	}

	// Shortcut.
	public static VJGraph		string_to_graph(String s)
	{
		Document doc = parse_from_string(s);

		if (doc == null)
			Debug.echo("string_to_graph: doc is null! WTF!!");
		VJGraph g = XMLConverter.xml_to_graph(doc);
		//   	apply_layout(g);
		return g;
	}


	public static Document		parse_from_filename(String s)
	{
		try
		{
			return parse(new InputSource(new FileReader(s)));
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		return null;
	}

	public static Document		parse_from_string(String s)
	{
		Debug.echo("---start xml automaton\n" + s);
		Document doc = parse(new InputSource(new StringReader(s)));

		if (doc == null)
			Debug.echo("parse_from_string: doc is null! WTF!!");
		return doc;
	}

	public static Document		parse(InputSource source)
	{
		try
		{
			// Create a DOM Parser
			DOMParser parser = new DOMParser();

			// Parse the incoming file (filename)
			parser.parse(source);
			Document doc = parser.getDocument();
			if (doc == null)
				Debug.echo("parse: doc is null! WTF!!");
			return doc;
		}
		catch (IOException ioe)
		{
			ioe.printStackTrace();
		}
		catch (SAXException saxe)
		{
			saxe.printStackTrace();
		}
		return null;
	}

	public static NodeList		get_type(Document doc)
	{
		Debug.echo("get_type");
		return ((Element)(doc.getElementsByTagName(VJToolKitConstants.XML_TAG_TYPE)
				.item(0))).getChildNodes();
	}

	public static NodeList		get_content(Document doc)
	{
		return ((Element)(doc.getElementsByTagName("content")
				.item(0))).getChildNodes();
	}


	// Retrieve informations of <geometry> tag.
	// If multiple values of a same key are present, the last is kept.
	public static Map			get_geometry(NodeList l)
	{
		Map				ret = new Hashtable();

		for (int i = 0; l != null && i < l.getLength(); ++i)
			if (l.item(i).getNodeType() == Node.ELEMENT_NODE &&
					l.item(i).getNodeName().equals("geometry"))
			{
				NamedNodeMap attrib = l.item(i).getAttributes();
				for (int j = 0; j < attrib.getLength(); ++j)
				{
					Debug.echo(attrib.item(j).getNodeName());
					Debug.echo(attrib.item(j).getNodeValue());
					ret.put(attrib.item(j).getNodeName(),
							attrib.item(j).getNodeValue());
				}
			}
		return ret;
	}

	// Retrieve informations of <drawing> tag.
	// If multiple values of a same key are present, the last is kept.
	public static Map			get_drawing(NodeList l)
	{
		Map				ret = new Hashtable();

		for (int i = 0; l != null && i < l.getLength(); ++i)
			if (l.item(i).getNodeType() == Node.ELEMENT_NODE &&
					l.item(i).getNodeName().equals("drawing"))
			{
				NamedNodeMap attrib = l.item(i).getAttributes();
				for (int j = 0; j < attrib.getLength(); ++j)
					ret.put(attrib.item(j).getNodeName(),
							attrib.item(j).getNodeValue());
			}
		return ret;
	}
}
